<%-- forms\admin_framework\admin_add_remote_servers.jsp --%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="fn" uri = "http://java.sun.com/jsp/jstl/functions"%>

<%--
	This portion of the file populates all the remote servers attached to the
	central server. This will be invoked while the page loads and subsequently 
	when the remote servers gets added from central server.
--%>

<c:forEach items="${remoteServerList}" var="remoteServer">
	
	<c:set var="databasesLength" value="${fn:length(remoteServer.databases)}"/>
	
	<c:if test="${databasesLength >= 1}">
		<c:set var="rowspan" value="${databasesLength}"/>
	</c:if>
	<c:if test="${databasesLength == 0}">
		<c:set var="rowspan" value="1"/>
	</c:if>
	
	<c:choose>
		<c:when test="${param.ascend}">
			<c:set var="location" value="0"/>
			<c:set var="begin" value="1"/>
			<c:set var="end" value="${databasesLength - 1}"/>
		</c:when>
		<c:otherwise>
			<c:set var="location" value="${databasesLength - 1}"/>
			<c:set var="begin" value="0"/>
			<c:set var="end" value="${databasesLength - 2}"/>
		</c:otherwise>
	</c:choose>
	
	<tr id="${remoteServer.url}"> 
		<td rowspan="${rowspan}" width="5%">
			<%-- Name --%>
			<input type="hidden" id="name-${remoteServer.url}" value="${remoteServer.name}">
			${remoteServer.name}
		</td> 
		<td rowspan="${rowspan}" width="10%">
			<%-- Address --%>
			<c:set var="remoteUrl"/>
			<c:set var="remoteUrl">
				<%-- fn:endsWith is not working as expected, that's why using 
				fn:substringAfter to find if '/' is present in the last or not --%>
				<c:set var="temp" value="${fn:substringAfter(remoteServer.url,'//')}"/>
				<c:choose>
					<c:when test="${fn:contains(temp, '/')}">
						${remoteServer.url}
					</c:when>
					<c:otherwise>
						${remoteServer.url}/
					</c:otherwise>
				</c:choose>
			</c:set>
			<a onclick="javascript: remoteLogin('${remoteUrl}');" style="text-decoration: underline;cursor:pointer;">
				${remoteUrl}
			</a> 
		</td>
		
		<td rowspan="${rowspan}" colspan="2" id="wait-${remoteServer.url}" style="text-align: center;" width="20%">
			<img id="active_user_chart" src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">
			<change:resource key="loadingData"/>
		</td>
		
		<td rowspan="${rowspan}" id="status-${remoteServer.url}" style="display: none; text-align: center;" width="5%">
			<%-- Status - Load status after page loads --%>
		</td> 
		<td rowspan="${rowspan}" id="responseTime-${remoteServer.url}" style="display: none; text-align: center;" width="8%">
			<%-- Response Time - Load ping time after page loads --%>
		</td>
		<c:set var="database" value="${remoteServer.databases[location]}"/>
		<c:set var="databaseNotAvailable" value="${database.status == 'UNAVAILABLE' 
				|| database.status == 'DISABLED' || database.status == 'PROTECTED'}"/>
		
		<c:choose>
			<c:when test="${databasesLength == 0}">
					<td align="center" colspan="4" rowspan="1" width="55%">
						<change:resource key="noValidDatabases"/>
					</td>							
			</c:when>
			<c:when test="${!databaseNotAvailable}">
				<td rowspan="1" width="5%">
					<%-- Name --%>
					${database.label}
				</td> 
				<td rowspan="1" width="10%">
					<%-- Path --%>
					${database.name}
				</td> 
				<td rowspan="1" width="5%">
					<%-- Status --%>
					${database.localizedStatus}
				</td>
				<td rowspan="1">
					<%-- Status Message --%>
					<change:resource key="available"/>
				</td>
			</c:when>		
			<c:otherwise>
				<td style="color: red;" rowspan="1" width="5%">
					<%-- Name --%>
					${database.label}
				</td> 
				<td style="color: red;" rowspan="1" width="10%">
					<%-- Path --%>
					${database.name}
				</td> 
				<td style="color: red;" rowspan="1" width="5%">
					<%-- Status --%>
					${database.localizedStatus}
				</td>
				<td rowspan="1" align="left" style="padding: 0px 0px 0px 0px">
					<%-- Status Message --%>
					<c:set var="statusMessage" value="${database.lastSessionError}"/>
					<c:if test="${database.status == 'UNAVAILABLE'}">
						<c:set var="statusMessage">
							 <change:resource key='databaseUnavailable'/>
						</c:set>
					</c:if>
					<c:choose>
						<c:when test="${statusMessage != ''}">
							<table class="status" width="100%" border="0" cellpadding="0" cellspacing="0">
								<tr>
									<td width="1%">
										<img src="<change:urlCreator webResource='PTIMAGES'/>warning_small.gif" border="0" vspace="2"/>
									</td>
									<td width="99%">
										${statusMessage}
									</td>
								</tr>
							</table>
						</c:when>
						<c:otherwise>
							<change:resource key="available"/>
						</c:otherwise>
					</c:choose>
				</td>
			</c:otherwise>
		</c:choose>
		<td rowspan="${rowspan}" style="text-align: center;" width="5%"> 
			<button onclick="showRemoveDlg('${remoteServer.url}')"><change:resource key="lbl01155"/></button>
		</td> 
	</tr>
	
	<c:if test="${databasesLength >= 2}">
		<c:forEach items="${remoteServer.databases}" var="databases" begin="${begin}" end="${end}">
			<c:set var="isDatabaseNotAvailable" value="${databases.status == 'UNAVAILABLE' 
				|| databases.status == 'DISABLED' || databases.status == 'PROTECTED'}"/>
			<c:choose>
				<c:when test="${!isDatabaseNotAvailable}">
					<tr id="databaseRows-${remoteServer.url}">
						<td width="5%">
							<%-- Name --%>
							${databases.label}
						</td> 
						<td width="10%">
							<%-- Path --%>
							${databases.name}
						</td> 
						<td width="5%">
							<%-- Status --%>
							${databases.localizedStatus}
						</td>
						<td rowspan="1">
							<%-- Status Message --%>
							<change:resource key="available"/>
						</td>
					</tr>
				</c:when>
				<c:otherwise>
					<tr style="color: red;" id="databaseRows-${remoteServer.url}">
						<td width="5%">
							<%-- Name --%>
							${databases.label}
						</td> 
						<td width="10%"> 
							<%-- Path --%>
							${databases.name}
						</td> 
						<td width="5%">
							${databases.localizedStatus}
						</td>
						<td rowspan="1" style="padding: 0px 0px 0px 0px">
							<%-- Status Message --%>
							<c:set var="statusMessage" value="${databases.lastSessionError}"/>
							<c:if test="${database.status == 'UNAVAILABLE'}">
								<c:set var="statusMessage">
									 <change:resource key='databaseUnavailable'/>
								</c:set>
							</c:if>
							<c:choose>
								<c:when test="${statusMessage != ''}">
									<table class="status" width="100%" border="0" cellpadding="0" cellspacing="0">
										<tr>
											<td width="1%">
												<img src="<change:urlCreator webResource='PTIMAGES'/>warning_small.gif" border="0" vspace="2"/>
											</td>
											<td width="99%">
												${statusMessage}
											</td>
										</tr>
									</table>
								</c:when>
								<c:otherwise>
									<change:resource key="available"/>
								</c:otherwise>
							</c:choose>
						</td>
					</tr>
				</c:otherwise> 
			</c:choose>				
		</c:forEach>
	</c:if>
</c:forEach>
