<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\admin_framework\admin_central_server.jsp -->
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>

<html>
	<head>
		<title><change:resource key='productName'></change:resource></title>
		<style type="text/css">
			@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css";
			
			<change:wsletExpander>
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=styles/default_admin.css -->
				<!-- /WSLET -->
			</change:wsletExpander>
			
			 .dojoDialog
			{
				background: white;
				border : 1px solid #999;
				-moz-border-radius : 5px;
				padding : 4px;
			}
			
			#dojoHeading
			{
				font-size: 100%;
				background-color: #DDD;
				margin-bottom: 10px;
				padding: 5px;
			}
		</style>
		
		<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
		<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
		<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
		<script type="text/javascript" src="dwr/interface/ServerRegistrarAjax.js"></script>		
		<script type="text/javascript">
			dojo.require('dijit.Dialog');
		</script>
		
		<script type="text/javascript">
			<change:wsletExpander>
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=validation.js -->
				<!-- PARAM NAME=EventUtils.js -->
				<!-- PARAM NAME=MessageFormat.js -->
				<!-- /WSLET -->
			</change:wsletExpander>
			
			var dlg;
			var unregisterDlg;
			var isRegistered = ${isRegistered};
			var keyHitNotAllowed = false;
			
			/**
		 	* On-load function.
		 	*/
			function onLoad()
			{
				if (${isRegistered})
				{
					ServerRegistrarAjax.isRemoteServerRegistered("${user.token}", {callback:isRemoteRegisteredCallback});
				}

				dlg = dijit.byId("centralServerLoginPopupDialog");
				unregisterDlg = dijit.byId("unRegisterPopupDialog");
				var nameOfThisServer = document.getElementById("nameOfThisServer");
				checkRegistrationStatus(null, ${isRegistered}, true);
				
				EventUtils.addEvent(document.getElementById('adminUser'), 'keypress', ok_onKeyup);
				EventUtils.addEvent(document.getElementById('password'), 'keypress', ok_onKeyup);				
			}

			/**
			* AJAX callback function to determine if this 
			* remote server is registered or not.
			*/
			function isRemoteRegisteredCallback(isRemoteRegistered)
			{
				if (!isRemoteRegistered)
				{
					var message = '<change:resource key="XcentralServerUnregisteredRemoteServer"><change:param value="${centralServerName}"></change:param></change:resource>';

					if (confirm(message))
					{
						showUnregisterDialog();
					}
				}
			}

			/**
			* Register the remote server. 
			*/
			function register_onClick()
			{
				if (validate(document.centralServerForm))
				{
					showDialog();
				}
			}

			/**
			* Display the CentralServer login modal dialog. 
			*/
			function showDialog()
			{
				dlg.show();
				resetPolicyDialog();
				dojo.byId("adminUser").focus();				
			}
			
			/**
			* Callback method invoked on pressing enter key.
			*/
			function ok_onKeyup(event)
			{
				if (event.keyCode == 13)
				{
					if (!keyHitNotAllowed)
					{
						okPopupClose();
					}	
				}
			}

			/**
			* Reset the elements in the CentralServer login modal dialog.
			*/
			function resetPolicyDialog()
			{
				dojo.byId("adminUser").value = "";
				dojo.byId("password").value = "";
				dojo.byId("waitMessage").value = "";
				dojo.byId("warnings").innerHTML = "";
				dojo.byId("warningIcon").style.display = "none";
				dojo.byId("centralServerLoginOk").disabled = false;
				dojo.byId("centralServerLoginHider").disabled = false;;
				
				document.getElementById("connecting").style.display = "none";
			}
			
			/**
			* The CentralServer login modal dialog has been dimissed by clicking the ok button,
			* capture the changes.
			*/
			function okPopupClose()
			{
				var adminUser = dojo.byId("adminUser");
				var password = dojo.byId("password");
				var warningsSpan = dojo.byId("warnings");
				var warningIcon = dojo.byId("warningIcon");
				document.getElementById("warningMsgs").style.display = "";
	
				if (adminUser.value == "")
				{
					var msg = '<change:resource key="XfieldCannotBeEmpty"><change:param><change:resource key="adminUser"/></change:param></change:resource>';
					warningIcon.style.display = "";
					warningsSpan.innerHTML = msg;
					adminUser.focus();
				}
				else if (password.value == "")
				{
					var msg = '<change:resource key="passwordRequired"/>';
					warningIcon.style.display = "";
					warningsSpan.innerHTML = msg;
					password.focus();
				}
				else 
				{
					keyHitNotAllowed = true;
					document.getElementById("connecting").style.display = "";
					warningIcon.style.display = "none";
					dojo.byId("warningMsgs").style.display = "none";
					dojo.byId("centralServerLoginOk").disabled = true;
					dojo.byId("centralServerLoginHider").disabled = true;
						
					if (!isRegistered) 
					{
						dojo.byId("waitMessage").innerHTML = '<change:resource key="registeringWithCentralServer"/>';
						
						ServerRegistrarAjax.registerRemoteFromRemoteServer("${user.token}",
							 document.getElementById("centralServerUrl").value,
							 document.getElementById("nameOfThisServer").value,
							 adminUser.value,		
							 password.value, {callback:registerCallback, errorHandler:registerFailureCallback});
					}
					else 
					{
						dojo.byId("waitMessage").innerHTML = '<change:resource key="unRegisteringWithCentralServer"/>';
						
						ServerRegistrarAjax.unregisterRemoteFromRemoteServer("${user.token}", 
							adminUser.value, password.value, {callback:unregisterCallback, errorHandler:unregisterFailureCallback});
					}
				}
			}
			
			/**
			* AJAX error callback function for Registering a remote server.
			*/
			function registerFailureCallback(errMessage)
			{
				keyHitNotAllowed = false;
				dlg.hide();
				alert(errMessage);
				var centralServerUrl = document.getElementById("centralServerUrl");
				centralServerUrl.focus();
				centralServerUrl.select();
			}
						
			/**
			* AJAX error callback function for Unregistering a remote server.
			*/
			function unregisterFailureCallback(errMessage)
			{
				keyHitNotAllowed = false;
				dlg.hide();
				alert(errMessage);
				self.location = "<change:urlCreator webResource='BASEURL'/>/centralServerFormLoader.do?"
					+ "token=${user.token}&formName=remote&methodToCall=executeRemoteServerAction";
			}
			
			/**
			* AJAX callback function for Registering a remote server.
			*/
			function registerCallback(registerResult)
			{
				if (registerResult.errorMessage == "")
				{
					dlg.hide();
					
					isRegistered = true;
					checkRegistrationStatus(registerResult, isRegistered, false);
					
					var formatter = new MessageFormat('<change:resource key="removeRemoteXfromCentralY"/>');
					var msg = formatter.format(["${remoteServerName}", registerResult.centralServerName]);
					
					document.getElementById("unregisterInformationalText").innerHTML = msg;
					keyHitNotAllowed = false;
					document.getElementById("unregister").focus();
				}
				else
				{
					invalidLogin(registerResult.errorMessage);
				}
			}
			
			/**
			* AJAX callback function for Unregistering a remote server.
			*/
			function unregisterCallback(errMessage)
			{
				if (errMessage == "")
				{
					keyHitNotAllowed = false;
					dlg.hide();
					
					isRegistered = false;
					checkRegistrationStatus(null, isRegistered, false);
					document.getElementById("centralServerUrl").focus();
				}
				else
				{
					invalidLogin(errMessage);
				}
			}
			
			/**
			* Display the eror message in the modal dialog on invalid login.
			*/			
			function invalidLogin(errMessage)
			{
				keyHitNotAllowed = false;
				var adminUser = dojo.byId("adminUser");
				dojo.byId("warningMsgs").style.display = "";
				dojo.byId("warningIcon").style.display = "";
				dojo.byId("warnings").innerHTML = errMessage;
				
				document.getElementById("connecting").style.display = "none";
				
				dojo.byId("centralServerLoginOk").disabled = false	;
				dojo.byId("centralServerLoginHider").disabled = false;;
				dojo.byId("password").value = "";
				adminUser.select();
				adminUser.focus();
			}
			
			/**
			* Close the CentralServer login modal dialog on clicking Cancel.
			*/	
			function cancelPopupClose()
			{
				dlg.hide();			
			}
			
			/**
			* Validate the form.
			*/
			function validate(objForm)
			{
				if((!hasNonWhiteSpaceChar(objForm.nameOfThisServer.value)))
				{
					alert('<change:resource key="XfieldCannotBeEmpty"><change:param><change:resource key="nameOfThisServer"/></change:param></change:resource>');
					objForm.nameOfThisServer.focus();
					
					return false;						
				}
				else if((!hasNonWhiteSpaceChar(objForm.centralServerUrl.value)))
				{
					alert('<change:resource key="XfieldCannotBeEmpty"><change:param><change:resource key="centralServerUrl"/></change:param></change:resource>');
					objForm.centralServerUrl.focus();
					
					return false;						
				}
				
				var url = trim(objForm.centralServerUrl.value);
				objForm.centralServerUrl.value = url;
				
				if ((url).match(/^(http[s]?):\/\/([\w.-]+):\d+?\/(([\w.-]+)\/)?$/i) == null)
				{
					alert('<change:resource key="wrongCentralServerUrl"/>');				
					objForm.centralServerUrl.focus();
					objForm.centralServerUrl.select();
					
					return false;								
				}
				
				return true;
			}
			
			/**
			* Unregister the remote server.
			*/
			function unRegister_onClick()
			{
				showUnregisterDialog();
			}
			
			/**
			* Display the Unregister modal dialog.
			*/
			function showUnregisterDialog()
			{
				unregisterDlg.show();
				dojo.byId("unRegisterOk").focus();
			}
			
			/**
			* The Unregister modal dialog has been dimissed by clicking the ok button,
			* capture the changes.
			*/
			function unRegisterOk()
			{
				unregisterDlg.hide();
				document.getElementById("unregister").focus();
				showDialog();
			}
			
			/**
			* Close the Unregister modal dialog on clicking Cancel.
			*/
			function unRegisterCancel()
			{
				unregisterDlg.hide();
				document.getElementById("unregister").focus();
			}
			
			/**
			*  Open the admin login page for the given central server
			*/
			function openCentralServerAdminLogin(centralServerUrl)
			{
				if (centralServerUrl == "")
				{
					centralServerUrl = document.getElementById("centralServerUrl").value;
				}
				
				window.open(centralServerUrl + "admin", 'adminLogin').focus();
			}
			
			//Check the status of the server(registered/unregistered) and display the fields in the page accordingly
			function checkRegistrationStatus(registerResult, isRegistered, isOnLoad)
			{
				var sharedCentralUrlTable = document.getElementById("sharedCentralUrlTable");
				var centralServerUrl = document.getElementById("centralServerUrl");
				var nameOfThisServer = document.getElementById("nameOfThisServer");
				var unregister = document.getElementById("unregister");
				var register = document.getElementById("register");
				var registeredRemoteServerName = document.getElementById("registeredServerName");
			
				if (isRegistered)
				{
					var centralServerUrlAnchor = document.getElementById("centralServerUrlAnchor");
					centralServerUrlAnchor.style.display = "";
					sharedCentralUrlTable.style.display = "";
					centralServerUrl.style.display = "none";
							
					// if the function is called on onload of the page than registerResult will not be available
					if (isOnLoad)
					{
						nameOfThisServer.value = "${remoteServerName}";
						registeredRemoteServerName.innerHTML = "${remoteServerName}";
						nameOfThisServer.style.display = "none";
					}
					else
					{
						//This part caters to the register ajax call.
						nameOfThisServer.value = registerResult.remoteServerName;
						registeredRemoteServerName.innerHTML = registerResult.remoteServerName;

						//remove the existing sharedCentralUrlTable and recreate one.
						var parentElement = sharedCentralUrlTable.parentNode;
						//parentElement.removeChild(sharedCentralUrlTable);
						var table = '<table id="sharedCentralUrlTable">' +
										'<tr valign="top">' +
											'<td valign="top">' +
												'<a onclick="javascript: openCentralServerAdminLogin(\''+ centralServerUrl.value + '\')" id="centralServerUrlAnchor" style="text-decoration: underline; cursor:pointer;">' +
												centralServerUrl.value + '</a>' +
											'</td>' +
										'</tr>' +
									'</table>' +
									'<table>' +
									'<tr>' +
										'<td>' +
											'<input type="text" size="30" id="centralServerUrl" name="centralServerUrl" style="display: none;"/>' +
										'</td>' +
									'</tr>' +
									'</table>';
						
						parentElement.innerHTML = table;
						nameOfThisServer.style.display = "none";
					}
			
					registeredRemoteServerName.style.display = "";
				}
				else
				{
					sharedCentralUrlTable.style.display = "none";
					centralServerUrl.style.display = "";
					centralServerUrl.disabled = false;
					centralServerUrl.value = "";
					nameOfThisServer.style.display = "";
					nameOfThisServer.disabled = false;
					nameOfThisServer.value = "${remoteServerName}";
					registeredRemoteServerName.innerHTML = "";
					nameOfThisServer.focus();
				}
				
				//botton's status depends on isRegistered value
				unregister.disabled = !isRegistered;	
				register.disabled = isRegistered;
			}
			
			dojo.addOnLoad(onLoad);			
		</script>
	</head>
	
	<body>
		<form method="post" name="centralServerForm">
			<br>
			<table align="center">
				<tr>
					<td align="right">
						<table>
							<tr>
								<td valign="baseline">
									<B>
										<label><change:resource key="nameOfThisServer"/></label>:
									</B>
								</td>
							</tr>
						</table>
					</td>
					<td align="left">
						<table>
							<tr>
								<td>
									<input type="text" size="30" id="nameOfThisServer" name="nameOfThisServer" style="display: none;"/>
									<span id="registeredServerName" style="display: none;"></span>
								</td>
							</tr>
						</table>							
					</td>
				</tr>
				<tr>
					<td  align="right" valign='<c:if test="${isRegistered}">top</c:if>'>
						<table>
							<tr>
								<td>
									<B>
										<label><change:resource key="centralServerUrl"/></label>:
									</B>
								</td>
							</tr>
						</table>
					</td>
					<td align="left" valign="top" >						
						<c:if test="${isRegistered}">
							<table id="sharedCentralUrlTable">
								<c:forEach items="${sharedCentralServerUrls}" var="sharedCentralServerUrl">
									<tr valign="top">
										<td valign="top">
											<a onclick="javascript: openCentralServerAdminLogin('${sharedCentralServerUrl}')" id="centralServerUrlAnchor" style="text-decoration: underline; cursor:pointer;">
											${sharedCentralServerUrl}</a>
										</td>
									</tr>
								</c:forEach>
							</table>
							<table>
								<tr>
									<td>
										<input type="text" size="30" id="centralServerUrl" name="0" style="display: none;"/>
									</td>
								</tr>
							</table>
						</c:if>
						<c:if test="${!isRegistered}"> 
							<table id="sharedCentralUrlTable">
								<tr>
									<td>
										<a onclick="javascript: openCentralServerAdminLogin();" id="centralServerUrlAnchor" style="display: none; text-decoration: underline;cursor:pointer;">
										</a>
									</td>
								</tr>
							</table>
							<table>
								<tr>
									<td>
										<input type="text" size="30" id="centralServerUrl" name="centralServerUrl"/>
									</td>
								</tr>
							</table>
						</c:if>	
					</td>
				</tr>	
			</table>
			<br>
			<table align="center" cellpadding="5">
				<tr>
					<td align="right">
						<button type="button" onclick="register_onClick();" id="register">
							<change:resource key='lblRegister'/>
						</button>
					</td>
					<td align="center">
						<button type="button" onclick="unRegister_onClick();" id="unregister">
							<change:resource key='unregister'/>
						</button>
					</td>
				</tr>
			</table>

			<div dojoType="dijit.Dialog" id="centralServerLoginPopupDialog" class="dojoDialog" duration="250" style="display: none">
				<table id="centralServerLoginTbl" style="width: 235px;">
					<tr>
						<td align="left" colspan="2" id="dojoHeading">
							<span id="popupheader"><B><change:resource key='centralServerLogin'/></B></span>
						</td>
					</tr>
					<tr id="centralServerLoginInformationalText">
						<td colspan="2" style="padding: 5px;">
							<change:resource key='centralServerInformationalText'/>
						</td>
					</tr>
					<tr id="warningMsgs" style="display: none">
						<td colspan="2">
							<center>
								<img id="warningIcon" style="display: none;" src="<change:urlCreator webResource='PTIMAGES'/>warning_small.gif">
								&nbsp;<span id="warnings"></span>
							</center>
						</td>
					</tr>	
					<tr>
						<td  align="right" style="padding-left: 3px;" NOWRAP>
							<label for="adminUser"><change:resource key='adminUser'/></label>:
						</td>
						<td align="left" style="padding: 3px;">
							<input id="adminUser" type="text"></input>
						</td>
					</tr>
					<tr>
						<td  align="right" style="padding-left: 3px;" NOWRAP>
							<label for="password"><change:resource key='lbl00004'/></label>
						</td>
						<td align="left" style="padding: 3px;">
							<input id="password" type="password"></input>
						</td>
					</tr>
					<tr id="connecting" style="display: none;">
						<td colspan="2" align="center" valign="middle">
							<img src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">&nbsp;&nbsp;
							<span id="waitMessage"></span>
						</td>
					</tr>
					<tr>
						<td colspan="2" align="center" style="padding: 10px;">
							<button id="centralServerLoginOk" onclick="javascript:okPopupClose();"><change:resource key='lbl01157'/></button>
							&nbsp;&nbsp;
							<button id="centralServerLoginHider" onclick="javascript:cancelPopupClose();"><change:resource key='lbl00249'/></button>
						</td>
					</tr>
				</table>
			</div>

			<div dojoType="dijit.Dialog" id="unRegisterPopupDialog" class="dojoDialog" duration="250" style="display: none">
				<table id="unRegisterTbl" style="width: 570px;">
					<tr>
						<td align="left" colspan="2" id="dojoHeading">
							<span id="unRegisterPopupheader"><B><change:resource key='unregister'/></B></span>
						</td>
					</tr>
					<tr>
						<td id="unregisterInformationalText" style="padding: 10px;">
							<c:if test="${isRegistered}">
								<change:resource key='removeRemoteXfromCentralY'>
									<change:param value="${remoteServerName}"></change:param>
									<change:param value="${centralServerName}"></change:param>
								</change:resource>
							</c:if>
						</td>
					</tr>
					<tr>
						<td align="center" style="padding: 10px;">
							<button id="unRegisterOk" onclick="javascript:unRegisterOk();"><change:resource key='lbl01157'/></button>
							&nbsp;&nbsp;
							<button id="unRegisterHider" onclick="javascript:unRegisterCancel();"><change:resource key='lbl00249'/></button>
						</td>
					</tr>
				</table>
			</div>
		</form>
	</body>
</html>
