<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\admin_framework\admin_remote_servers.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fn" uri = "http://java.sun.com/jsp/jstl/functions"%>

<!--  
	admin_remote_servers.jsp is the main page for the Remote Servers tab. 
	It also contains logic to add and remove remote servers 
-->

<html>
	<head>
		<title>
			<change:resource key='productName'></change:resource>
		</title>
	
		<style>
			@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css";

			<change:wsletExpander>
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM name=styles/default.css -->
				<!-- PARAM name=styles/remote_servers.css -->
				<!-- /WSLET -->
			</change:wsletExpander>
		</style>
		
		<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
		<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
		<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>		
		<script type="text/javascript" src="dwr/interface/ServerRegistrarAjax.js"></script>

		<script type="text/javascript">
			dojo.require('dijit.Dialog');
			dojo.require('dijit.Tooltip');
		</script>

		<script>
			<change:wsletExpander>
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM name=toggleSection.js -->
				<!-- PARAM name=StyleUtils.js -->
				<!-- PARAM name=GenericTableSorter.js -->
				<!-- PARAM name=domUtilities.js -->
				<!-- PARAM name=Zebra.js -->
				<!-- PARAM name=ScrapeText.js -->
				<!-- PARAM name=EventUtils.js -->
				<!-- PARAM name=admin_framework/utils.js -->
				<!-- PARAM NAME=validation.js -->
				<!-- PARAM name=MessageFormat.js -->
				<!-- PARAM name=findObjectPositionUtils.js -->
				<!-- /WSLET -->
			</change:wsletExpander>
		
			/**
			 * Functions to read the "visible" values of each logical column.
			 * Each array index is a function to read the column with the same index.
			 * Used both in sorting and filtering, which both act on what the user sees
			 * (not necessarily the underlying values of the controls.).
			 */
			var gColumnValueFunctions = 
			[
				function(row)
				{
					return ScrapeText.fromTextNodes(row.cells[0]);
				},
		
				function(row)
				{
					return ScrapeText.fromTextNodes(row.cells[1]);
				},
		
				function(row)
				{
					return ScrapeText.fromTextNodes(row.cells[2]);
				},
		
				function(row)
				{
					return ScrapeText.fromTextNodes(row.cells[3]);
				},
			];
			
			var tableSorter;
			var isReverse;
			
			/**
			 * Initialize the table for sorting.
			 */
			function initOnLoad()
			{
				if (${fn:length(remoteServerList) > 0})
				{
					var remoteServers = $("remoteServers");
					var rowLength = remoteServers.rows.length;
					
					tableSorter = new GenericTableSorter(null, gColumnValueFunctions, "odd-row");
					tableSorter.body = remoteServers;
					
					// Default sort on name of the remote server. on name of the remote server.
					sortRemoteServers(remoteServers, $("remoteServerName")); 
					
					// Get Real ping time for all the Remote servers.
					for (var i = 0; i < rowLength; i++)
					{
						// Ping only for main row.
						if (remoteServers.rows[i].id.match(/^databaseRows-/i) == null)
						{
							ServerRegistrarAjax.pingRemoteServer("${user.token}", remoteServers.rows[i].id, pingCallback);
						}
					}
				}
			}
			
			
			/*
			 * Sotrs remote server's data
			 */
			function sortRemoteServers(body, id, isAjaxCallback)
			{
				// Return if body has no rows to sort. 
				if (!body)
				{
					if (tableSorter)
					{
						tableSorter.removeArrow();
					}
					
					return;
				}
				
				// Return if body has single row.
				if (getMainRowsCount(body) == 1)
				{	
					if (isAjaxCallback
						&& StyleUtils.hasClass(body.rows[0], "odd-row"))
					{
						StyleUtils.removeClass(body.rows[0], "odd-row");
						
						for (var i = 1; i < body.rows.length; i++)
						{
							StyleUtils.removeClass(body.rows[i], "odd-row");
						}
					}
					
					var bodyUserInput = $("bodyUserInput");
					var bodyAddRemoteLabel = $("bodyAddRemoteLabel");
					
					// Some how FF makes cell borders disappear. Altering the DOM corrects it.
					if (!document.all)
					{
						bodyUserInput.parentNode.insertBefore(
							bodyAddRemoteLabel.parentNode.removeChild(bodyAddRemoteLabel), bodyUserInput);
					}
					
					tableSorter.removeArrow();
				}
				
				var databaseRows = new Array();
				var currentRowId;
				
				// 1. Remove rows which are not required for sorting.
				databaseRows = removeDatabaseRows(body);
				
				// 2. Do a normal sort.
				tableSorter.sortOnHeader = sortHeader;// Override the sorting function.
				tableSorter.sortOnHeader(id);
				
				// 3. Add back the removed rows to the corrosponding main 
				// row and stripe the body.
				for (var i = 0; i < body.rows.length; i++)
				{
					if (body.rows[i].id.match(/^databaseRows-/i) != null)
					{
						continue;
					}
					
					var currNode = body.rows[i];
					var hasClass = StyleUtils.hasClass(currNode, "odd-row");
					var rowId = "databaseRows-" + currNode.id;
					
					// Add the row and stripe it. 
					for (var j = 0; j < databaseRows.length; j++)
					{
						if (rowId == databaseRows[j].id)
						{
							// insert the row
							body.insertBefore(databaseRows[j], currNode.nextSibling);
							
							// Stripe body row.
							if (hasClass)
							{
								StyleUtils.addClass(databaseRows[j], "odd-row");
							}
							else
							{
								StyleUtils.removeClass(databaseRows[j], "odd-row");
							}
							
							currNode = databaseRows[j];
						}
					}		
				}
			}
			
			
			/*
			 * Returns the no. of rows which are 
			 * candidate for sorting.
			 */
			function getMainRowsCount(body)
			{
				var count = 0;
				
				for (var i = 0; i < body.rows.length; i++)
				{
					if (body.rows[i].id.match(/^databaseRows-/i) == null)
					{
						count++;
					}
				}
				
				return count;
			}
			
			var removedDatabases = new Array();
			var isRowAvailable = false;
			
			/*
			 * Remove databse rows which are not required for sorting
			 */
			function removeDatabaseRows(body)
			{
				var resultDatabases = new Array();
				
				// Construcs a datastrucre (Array) if there 
				// is need to get new data. Otherwise just 
				// removes the rows. 
				for (var i = body.rows.length - 1, j = 0; i >= 0; i--)
				{
					if (body.rows[i].id.match(/^databaseRows-/i) != null) 
					{
						if (!isRowAvailable)
						{
							removedDatabases[j++] = body.removeChild(body.rows[i]);
						}
						else
						{
							body.removeChild(body.rows[i]);
						}
					}
				}
				
				// Reverse the Array.
				if (!isRowAvailable)
				{
					for (var i = removedDatabases.length - 1, j = 0; i >= 0; i--)
					{
						resultDatabases[j++] = removedDatabases[i];
					}
					
					removedDatabases = resultDatabases;					
				}

				// Got fresh data.
				isRowAvailable = true;
				
				return removedDatabases;
			}
			
			var lessResTime = "<10";

			/*
			 * Callback for pingRmoteServer Ajax call.
			 */
			function pingCallback(result)
			{
				// Convert JSon string to javascript object   
				var result = eval('(' + result + ')');
				var serverStatus = result.status;
				
				var status = $("status-" + result.remoteUrl);
				var responseTime = $("responseTime-" + result.remoteUrl);
				var waitLoadData = $("wait-" + result.remoteUrl);
				var isServerAvailable = true;
				
				waitLoadData.parentNode.removeChild(waitLoadData);
				status.style.display = "";
				responseTime.style.display = "";
				
				// If server status is unavailable, show status as a link.
				if (result.errorMessage)
				{
					 
					serverStatus = '<a href="#" id="server-'+  result.remoteUrl +'">' + serverStatus + '</a>';
					isServerAvailable = false;
				}
				
				status.innerHTML = serverStatus;
				responseTime.innerHTML = (result.responseTime < 10)
					? lessResTime
					: result.responseTime;
				
				if (!isServerAvailable)
				{
					new dijit.Tooltip(
					{
						label: result.errorMessage, 
						connectId: ["server-"+result.remoteUrl],
						duration: 0,
						showDelay: 0
					});
				}		
			}
			
			/*
			 * Prompts user to enter remote server URL.
			 */
			function showAddNewRemoteInput()
			{
				$("bodyAddRemoteLabel").style.display = "none"; 
				$("bodyUserInput").style.display = "";
				$("remoteURL").focus();
				
				var addWaitIndicator = $("addWaitIndicator");
				
				if (addWaitIndicator.style.display == "")
				{
					addWaitIndicator.style.display = "none";
				}
				else
				{
					$("remoteURL").value = "";
				}
			}
			
			
			/*
			 * Shows "Add a Remote Server" link
			 */
			function showAddNewRemote()
			{
				$("addWaitIndicator").style.display = "none";
				$("bodyUserInput").style.display = "none"; 
				
				$("bodyAddRemoteLabel").style.display = ""; 
			}
			
			
			/*
			 * Adds a remote server by making an Ajax call.
			 */
			function addRemoteServer()
			{
				var remoteUrl = $("remoteURL").value;
				
				if (!isValidUrl(remoteUrl))
				{
					$("remoteURL").select();
					return;
				}
				
				$("bodyUserInput").style.display = "none";
				$("addWaitIndicator").style.display = "";		
				
				// Ajax call to register remote server.
				ServerRegistrarAjax.registerRemoteFromCentralServer("${user.token}", trim(remoteUrl), 
				{
					callback: addRemoteServerCallback, 
					errorHandler: addRemoteServerErrorHandler
				});
			}
			
			
			/*
			 * Populate the data for the added remote server.
			 */
			function addRemoteServerCallback(result)
			{
				var remoteServers = $("remoteServers");
				var dynamicData = $("dynamicData");
				
				// Empty tbody makes table border disappear in FF.
				// So create tbody (if empty) on-the-fly.								
				if (!remoteServers)
				{
					remoteServers = document.createElement("tbody");
					remoteServers.id = "remoteServers";
					var bodyAddRemoteLabel = $("bodyAddRemoteLabel");
					
					bodyAddRemoteLabel.parentNode.insertBefore(remoteServers, bodyAddRemoteLabel);
					
					tableSorter = new GenericTableSorter(null, gColumnValueFunctions, "odd-row");
					tableSorter.body = remoteServers;
				}
								
				// innerHTML does not work well with TD, TR and TBODY elements in IE.
				// Work around is to wrap data around <table> and take out the elements you need.
				// This solution works well in both IE and Firefox.
				dynamicData.innerHTML = '<table><tbody id="remoteServerData">' + result + '</tbody></table>';				
				var remoteServerData = $("remoteServerData").rows;
				
				// Get real ping time of the newly added remote server.
				ServerRegistrarAjax.pingRemoteServer("${user.token}", remoteServerData[0].id, pingCallback);
				
				var before;
				var remoteIdRemove;
				
				for (var i = remoteServerData.length - 1; i >= 0; i--)
				{
					if (before) 
					{
						remoteServers.insertBefore(remoteServerData[i], before);
					} 
					else 
					{
						remoteIdRemove = remoteServerData[i].id;
						remoteServers.appendChild(remoteServerData[i]);
						before = remoteServerData[i];																	
					}
				}
									
				tableSorter.isReversed = true;
				isRowAvailable = false; // Need fresh data.
				
				// Since a new row has been added, it will spoil the current sort.
				// To alivate this problem, apply a default sort on name of the 
				// remote server.
				sortRemoteServers($("remoteServers"), $("remoteServerName"), true);
				
				dynamicData.innerHTML = "";
				showAddNewRemote();
			}

			
			/*
			 * Error handler for adding remote server. 
			 */
			function addRemoteServerErrorHandler(errorString)
			{
				showAddNewRemoteInput();
				alert(errorString);
				$("remoteURL").select();
			}
			
			var remoteURL;
			var removeDialog;
			
			/*
			 * Shows modal overlay dialog for removing remote server. 
			 */
			function showRemoveDlg(url)
			{
				var remoteServerName = $("name-" + url).value;
				
				var formatter = new MessageFormat('<change:resource key="removeRemoteXfromCentralY"/>');
				var infoText = formatter.format([remoteServerName, "${centralServerName}"]);
				
				// Poplulate info message
				$("databaseRemovalInfo").innerHTML = infoText;
				
				removeDialog = dijit.byId("removeRemoteDojo");
				remoteURL = url;
				removeDialog.show();
				dojo.byId("removeOk").focus();
			}
			
			/*
			 * Unregister remote server by making an Ajax call.
			 */
			function removeOk()
			{
				var remoteServers = $(remoteURL).parentNode;
				var waitIndicator = $("removeWaitIndicator").cloneNode(true);
				
				removeRowspanRows(remoteURL);
				remoteServers.replaceChild(waitIndicator, $(remoteURL));
				removeDialog.hide();
				waitIndicator.style.display = "";
				
				// Ajax call to unregister remote server.
				ServerRegistrarAjax.unregisterRemoteFromCentralServer("${user.token}", remoteURL,  
				{
					callback: removeReomteServerCallback, 
					errorHandler: removeReomteServerErrorHandler
				});
				
				
				/*
			 	 * Unregister successful callback.
			 	 */
				function removeReomteServerCallback(result)
				{
					removeRow();
					document.getElementById("addRemoteLabel").focus();
				}
				
				
				/*
			 	 * Unregister failed callback.
			 	 */
				function removeReomteServerErrorHandler(result)
				{
					// Convert JSon string to javascript object   
					var result = eval('(' + result + ')');
					alert(result.errorMessage);
					
					if (result.isLocalUnregisterSuccess)
					{
						removeRow();
					}
					else
					{
						window.document.centralServerFormLoader.submit();
					}
				}
				
				
				/*
			 	 * Removes the corrosponding row.
			 	 */
				function removeRow()
				{
					remoteServers.removeChild(waitIndicator);
	
					if (remoteServers.rows.length == 0)
					{
						tableSorter.removeArrow();
						remoteServers.parentNode.removeChild(remoteServers);
					}				
					else
					{
						tableSorter.isReversed = true;
						
						// Default sort on name of the remote server.
						sortRemoteServers($("remoteServers"), $("remoteServerName"), true);
					}
				}
			}
			
			/*
		 	 * Removes all but one row in the given rowspan.
		 	 */
			function removeRowspanRows(mainRowId)
			{
				var body = $("remoteServers");
				
				for (var i = body.rows.length - 1; i >= 0; i--)
				{
					var rowId = "databaseRows-" + mainRowId;
					
					if (rowId == body.rows[i].id)
					{
						body.removeChild(body.rows[i]);
					}
				}
				
				// Need fresh data.
				isRowAvailable = false;
			}
			
			
			/*
		 	 * Hide the modal overlay dialog.
		 	 */
			function removeCancel()
			{
				removeDialog.hide();
			}		
			
			
			/**
			 * Opens remote server login page. 
			 */
			function remoteLogin(remoteURL) 
			{
				window.open(remoteURL + "admin").focus();
			}
			
			
			/**
			* Validates the given URL.
			*/
			function isValidUrl(remoteUrl)
			{
				var message = '<change:resource key="wrongRemoteServerUrl"/>';
				
				if ((!hasNonWhiteSpaceChar(remoteUrl)))
				{
					alert(message);
					return false;						
				}

				remoteUrl = trim(remoteUrl);

				if (remoteUrl.match(/^(http[s]?):\/\/([\w.-]+):\d+?\/(([\w.-]+)\/)?$/i) == null)
				{
					alert(message);				
					return false;								
				}
				
				return true;
			}
			
			
			/**
			 * Add a remote server if enter key is pressed.
			 */
			function handleOnKeyPress(evt, keyCode, fcn)
			{				
				EventUtils.handleKeyPress(evt, keyCode, fcn);
			}
			
			
			/**
			 * This function is used to sort the table for GenericTableSorter. 
			 * Override the sortOnHeader function GenericTableSorter.			 
			 */ 
			function sortHeader(header)
			{	
				var columnIndex = header.cellIndex;
				
				if (this.lastColumn == columnIndex)
				{
					this.isReversed = !this.isReversed;
				}
				else
				{
					this.lastColumn = columnIndex;
					this.isReversed = false;
				}
			
				this.refreshArrow(header);
				
				var readerFunc = this.columnReaderFunctions[columnIndex];
				var reversed = this.isReversed;
			
				var tempRows = new Array(this.body.rows.length);
				var comparator = sortString; // Default String sort.
				
				if (header.id == "remoteServerResTime")
				{
					var tempRowsStr = new Array();
					var tempRowsNum = new Array();
					
					for (var i = 0; i < this.body.rows.length; i++)
					{
						var value = readerFunc(this.body.rows[i]);
						
						if ((value != lessResTime) && isNaN(value))
						{
							tempRowsStr.push(this.body.rows[i]); 
						}
						else
						{
							tempRowsNum.push(this.body.rows[i]); 
						}
					}
					
					tempRowsStr.sort(sortString);
					tempRowsNum.sort(sortNumeric);
					
					var iMain = 0;
					
					if (this.isReversed)
					{
						for (var iStr = 0; iStr < tempRowsStr.length; iStr++)
						{
							tempRows[iMain++] = tempRowsStr[iStr];
						}
						
						for (var iNum = 0; iNum < tempRowsNum.length; iNum++)
						{
							tempRows[iMain++] = tempRowsNum[iNum];
						}
					}
					else
					{
						for (var iNum = 0; iNum < tempRowsNum.length; iNum++)
						{
							tempRows[iMain++] = tempRowsNum[iNum];
						}
						
						for (var iStr = 0; iStr < tempRowsStr.length; iStr++)
						{
							tempRows[iMain++] = tempRowsStr[iStr];
						}												
					}
				}
				else
				{
					for (var i = 0; i < tempRows.length; i++)
					{
						tempRows[i] = this.body.rows[i];
					}
				
					if (!isNaN(readerFunc(tempRows[0])))
					{
						// Numeric sorting
						comparator = sortNumeric;
					}
					else
					{
						var tempValue = readerFunc(tempRows[0]);
						tempValue = tempValue.substring(tempValue.lastIndexOf(':') + 1);
				
						// Check for validity of IP address
						if (tempValue.search(/^([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3})$/) != -1)
						{
							// String and IP address sorting
							comparator = sortStringAndIPAddress;
						}
					}
					
					tempRows.sort(comparator);
				}
				
				for (var i = 0; i < tempRows.length; i++)
				{
					this.body.appendChild(tempRows[i]);
				}
				
				if (this.oddRowClass)
				{
					Zebra.stripeBody(this.body, 'odd-row');
				}
				
				function sortString(leftRow, rightRow)
				{
					var left = readerFunc(leftRow).toLowerCase();
					var right = readerFunc(rightRow).toLowerCase();
			
					if (reversed)
					{
						var temp = left;
						left = right;
						right = temp;
					}

					if (left < right)
					{
						return -1;
					}
					else if (left > right)
					{
						return 1;
					}
					else
					{
						return 0;
					}
				}
			
				function sortNumeric(leftRow, rightRow)
				{
					left = parseFloat(readerFunc(leftRow));
					right = parseFloat(readerFunc(rightRow));
			
					if (isNaN(left))
					{
						left = 0;
					}
			
					if (isNaN(right))
					{
						right = 0;
					}
			
					if (reversed)
					{
						var temp = left;
						left = right;
						right = temp;
					}
			
					return left - right;
				}
			
				/**
				 * This custom sort function correctly sorts Strings which include and IP addresses.
				 * Format of string is <hostname:port-number:ip-address>.
				 * The function is "safe" i.e. non-IP address data (like the word "Unknown")
				 * can be passed in and is sorted properly.
				 */
				function sortStringAndIPAddress(leftRow, rightRow)
				{
					// Get the innerText of the TR nodes
					var left = readerFunc(leftRow);
					var right = readerFunc(rightRow);
			
					// Remove spaces
					left = left.replace(" ", "");
					right = right.replace(" ", "");
			
					if (reversed)
					{
						var temp = left;
						left = right;
						right = temp;
					}
			
					tempArrayLeft = left.split(':');
					tempArrayRight = right.split(':');
			
					if (tempArrayLeft[0] < tempArrayRight[0]
							|| parseFloat(tempArrayLeft[1]) < parseFloat(tempArrayRight[1])
							|| recursiveIPCheck(tempArrayLeft[2].split('.'), tempArrayRight[2].split('.')) < 0)
					{
						return -1;
					}
					else if (tempArrayLeft[0] > tempArrayRight[0]
							|| parseFloat(tempArrayLeft[1]) > parseFloat(tempArrayRight[1])
							|| recursiveIPCheck(tempArrayLeft[2].split('.'), tempArrayRight[2].split('.')) > 0)
					{
						return 1;
					}
					else
					{
						return 0;
					}
				}			
			}

			dojo.addOnLoad(initOnLoad);
		</script>
	</head>

	<body id="mainBody">
		<br><br>
		
		<table class="remoteServersTable" id="remoteServersTable">
			<thead> 
				<tr id="sort-on-header">
					<th rowspan="2" id="remoteServerName">
						<a href="javascript:sortRemoteServers($('remoteServers'), $('remoteServerName'))"	
							class="sort-header" style="text-decoration: underline">
							<change:resource key="lbl01131"/></a>
					</th>
					<th rowspan="2" id="remoteServerAddress">
						<a href="javascript:sortRemoteServers($('remoteServers'), $('remoteServerAddress'))"	
							class="sort-header" style="text-decoration: underline">
							<change:resource key="hostAddress"/></a>
					</th>
					<th rowspan="2" id="remoteServerStatus">
						<a href="javascript:sortRemoteServers($('remoteServers'), $('remoteServerStatus'))"	
							class="sort-header" style="text-decoration: underline">
							<change:resource key="lbl00106"/></a>
					</th>
					<th rowspan="2" id="remoteServerResTime">
						<a href="javascript:sortRemoteServers($('remoteServers'), $('remoteServerResTime'))"	
							class="sort-header" style="text-decoration: underline">
							<change:resource key="responseTime"/></a>
					</th>
					<th rowspan="1" colspan="4">
						<change:resource key="lbl00658"/>
					</th>
					<th rowspan="2">
						&nbsp;
					</th>
				</tr>
				
				<tr>
					<th rowspan="1">
						<change:resource key="lbl01131"/>
					</th>
					<th rowspan="1">
						<change:resource key="path"/>
					</th>
					<th rowspan="1">
						<change:resource key="lbl00106"/>
					</th>
					<th rowspan="1">
						<change:resource key="statusMessage"/>
					</th>
				</tr>
			</thead>				
			
			<c:if test="${fn:length(remoteServerList) > 0}">	
				<tbody id="remoteServers">				
					<%-- In this body all the registered remote servers will be shown --%>			
					<jsp:include page="/WEB-INF/wsconfig/templates/pt/forms/admin_framework/admin_add_remote_servers.jsp?ascend=true"/>
				</tbody>
			</c:if>
					
			<tbody style="background-color: #fff9b0;" id="bodyAddRemoteLabel">
				<tr>
					<td colspan="9" style="white-space: nowrap; text-align: center;">
						<a href="javascript: showAddNewRemoteInput();" id="addRemoteLabel" style="text-decoration: underline;">
							<change:resource key="addRemoteServer"/>
						</a>
					</td>
				</tr>
			</tbody>
			
			<tbody style="background-color: #fff9b0; display: none;" id="bodyUserInput">
				<tr>
					<td colspan="9" style="text-align: center; white-space: nowrap;">
						<label for="remoteURL">
							<change:resource key="enterRemoteServerUrl"/>
						</label>
						<input type="text" id="remoteURL" value="" style="width: 28%;" 
							onkeypress="handleOnKeyPress(event, 13, addRemoteServer);">
						<button id="addRemoteServer" onclick="addRemoteServer()"><change:resource key="lbl00333"/></button>
						<button id="cancel" onclick="showAddNewRemote()"><change:resource key="lbl00249"/></button>
					</td>
				</tr>
			</tbody>
			
			<tbody style="background-color: #fff9b0; display: none;" id="addWaitIndicator">
				<tr>
					<td colspan="9" style="text-align: center;">
						<img src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">
						<change:resource key="addingRemoteServer"/>
					</td>
				</tr>
			</tbody>
			
			<tr style="background-color: #D2D2D2; display: none;" id="removeWaitIndicator">
				<td colspan="9" style="text-align: center;" valign="middle">
					<img src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">
					<change:resource key="removingRemoteServer"/>
				</td>
			</tr>
		</table>
				
		<div id="dynamicData" style='visibility:hidden'></div>
		
		<div dojoType="dijit.Dialog" id="removeRemoteDojo" class="dojoDialog">
			<table class="barHeading" style="width: 580px;">
				<tr>
					<th>
						<change:resource key="removeRemoteServer"/>
					</th>
				</tr>
			</table>

			<table class="removeRemoteTable">
				<tr>
					<td id="databaseRemovalInfo">
					</td>
				</tr>
				<tr>
					<td colspan="2" style="padding: 10px; text-align: center;">
						<button id="removeOk" onclick="javascript:removeOk();"><change:resource key="lbl01157"/></button>
						&nbsp;&nbsp;
						<button id="removeRemoteHider" onclick="javascript:removeCancel();"><change:resource key="lbl00249"/></button>
					</td>
				</tr>
			</table>
		</div>
	</body>
	<form name="centralServerFormLoader" action="<change:urlCreator webResource='BASEURL'/>/centralServerFormLoader.do" class="hiddenForm" method="POST" target="_self">
		<input name="token" type="hidden" value="${user.token}">
		<input name="formName" type="hidden" value="central">
		<input name="methodToCall" type="hidden" value="executeCentralServerAction">
	</form>
</html>
