<!-- forms\admin_framework\admin_search_configure.jsp -->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<html>
<head>

	<style type="text/css">
<!--

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/default.css -->
	<!-- PARAM NAME=styles/tabs.css -->
	<!-- /WSLET -->
</change:wsletExpander>

BUTTON.columnButton
{
	width: 80px;
	display: block;
}

-->
	</style>
	
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
	
	<script type="text/javascript">
<!--

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=emphasis.js -->
	<!-- PARAM NAME=SelectUtils.js -->
	<!-- PARAM NAME=StyleUtils.js -->
	<!-- /WSLET -->
</change:wsletExpander>	

<change:wsletExpander>
	<!-- WSLET CODE=PTAdmin -->
	<!-- PARAM NAME=ATTRIBUTE_DATA VALUE=REPORTABLE_ATTRIBUTES -->
	<!-- PARAM NAME=JAVASCRIPT_IDENTIFIER VALUE=reportableCrAttributes -->
	<!-- PARAM NAME=ADDITIONAL_ATTRIBUTES VALUE=cvtype -->
	<!-- /WSLET -->
</change:wsletExpander>	

<change:wsletExpander>
	<!-- WSLET CODE=PTAdmin -->
	<!-- PARAM NAME=ATTRIBUTE_DATA VALUE=REPORTABLE_TASK_ATTRIBUTES -->
	<!-- PARAM NAME=JAVASCRIPT_IDENTIFIER VALUE=reportableTaskAttributes -->
	<!-- PARAM NAME=ADDITIONAL_ATTRIBUTES VALUE=cvtype -->
	<!-- /WSLET -->
</change:wsletExpander>	

var crSearchDisplayAttributes = new Array();
<c:forEach items="${crSearchDisplayAttribtues}" var="attribute" varStatus="status">
	crSearchDisplayAttributes[${status.index}] = <change:javaScriptEscape value="${attribute}"/>;
</c:forEach>

var originalCrSearchDisplayAttributes = crSearchDisplayAttributes.slice();

var taskSearchDisplayAttributes = new Array();
<c:forEach items="${taskSearchDisplayAttribtues}" var="attribute" varStatus="status">
	taskSearchDisplayAttributes[${status.index}] = <change:javaScriptEscape value="${attribute}"/>;
</c:forEach>

var originalTaskSearchDisplayAttributes = taskSearchDisplayAttributes.slice();

var gAttributeNamesToLabels;
var gCurrentTab = 0;

function mapAttributeNamesToLabels()
{
	var map = {};
	
	var attributeArrays = [reportableCrAttributes, reportableTaskAttributes];
	
	for (var attributesIndex = 0; attributesIndex < attributeArrays.length; attributesIndex++)
	{
		var attributes = attributeArrays[attributesIndex];

		for (var i = 0; i < attributes.length; i++)
		{
			map[attributes[i].name] = attributes[i].label;
		}
	}

	return map;
}

function initialize()
{	
	gAttributeNamesToLabels = mapAttributeNamesToLabels()
	displayCorrectAttributes(0, false);
}

function loadSourceAttributes(attributes)
{
	var sourceAttrs = document.getElementById("sourceAttributes");
	sourceAttrs.length = 0;
	
	for (var i = 0; i < attributes.length; i++)
	{
		if ((attributes[i].type != "CCM_DATE") 
		 && (attributes[i].type != "CCM_TEXT")
		 && (attributes[i].type != "CCM_ANNOTATED_TEXT")
		 && (attributes[i].type != "CCM_EXTENDED_TEXT")
		 && (attributes[i].type != "CCM_E_SIGNATURE")
		 && (attributes[i].type != "CCM_SUBSCRIPTION")
		 && (attributes[i].type != "CCM_LOG")
		 && (attributes[i].type != "CCM_PAGE_NAVIGATE")
		 && (attributes[i].type != "CCM_START_SEC")
		 && (attributes[i].type != "CCM_END_SEC")
		 && (attributes[i].type != "CCM_VISUAL_STATUS")
		 && (attributes[i].type != "CCM_PROGRESS_BAR")
		 && (attributes[i].type != "OSLC_LINK"))
		{
			SelectUtils.addOption(
				sourceAttrs, 
				attributes[i].label, 
				attributes[i].name, 
				false);
		}
	}
}

function loadSelectedAttributes(attributes)
{
	var selectedAttrs = document.getElementById("selectedAttributes");
	selectedAttrs.length = 0;
	
	for (var i = 0; i < attributes.length; i++)
	{
		SelectUtils.addOption(
			selectedAttrs, 
			window.gAttributeNamesToLabels[attributes[i]], 
			attributes[i], 
			false);
	}
}

function tab_onclick(a)
{
	if (a.disabled)
	{
		return;
	}
	
	var li = a.parentNode;
	var siblings = li.parentNode.getElementsByTagName("li");

	for (var i = 0; i < siblings.length; i++)
	{
		var sibling = siblings[i];

		if (sibling == li)
		{
			sibling.getElementsByTagName("a")[0].className = "current";
			displayCorrectAttributes(i, true);
			gCurrentTab = i;
		}
		else
		{
			sibling.getElementsByTagName("a")[0].className = "";
		}
	}
}

// Display the iframe that needs to be displayed and hide the others.
// 0 = CRs
// 1 = Tasks
function displayCorrectAttributes(tabIndex, performUpdate)
{
	if (tabIndex == 0)
	{
		if (performUpdate)
		{
			taskSearchDisplayAttributes = SelectUtils.getValues(
				document.getElementById("selectedAttributes"));
		}
			
		loadSourceAttributes(reportableCrAttributes);
		loadSelectedAttributes(crSearchDisplayAttributes);
	}
	else
	{
		if (performUpdate)
		{
			crSearchDisplayAttributes = SelectUtils.getValues(
				document.getElementById("selectedAttributes"));
		}
			
		loadSourceAttributes(reportableTaskAttributes);
		loadSelectedAttributes(taskSearchDisplayAttributes);
		
	}
}

function save_onclick()
{
	switch (gCurrentTab)
	{
	case 0:
		crSearchDisplayAttributes = SelectUtils.getValues(
				document.getElementById("selectedAttributes"));
		break;
	case 1:
		taskSearchDisplayAttributes = SelectUtils.getValues(
				document.getElementById("selectedAttributes"));
		break;
	default:
			//shouldn't ever be here.
	}
	
	var crAttributesToSave = crSearchDisplayAttributes.join("|");
	var taskAttributesToSave = taskSearchDisplayAttributes.join("|");
	
	var regenerate = needToRegenerateIndex();

	if (regenerate)
	{
		//see if they really want to regenerate the index.
		if (!window.confirm("<change:resource key="askSearchRegenerate"/>"))
		{
			return;
		}
	}
	
	window.document.saveSearchAttributes.crAttributes.value = crAttributesToSave;
	window.document.saveSearchAttributes.taskAttributes.value = taskAttributesToSave;
	window.document.saveSearchAttributes.regenerate.value = regenerate;
	
	window.document.saveSearchAttributes.submit();
}

function needToRegenerateIndex()
{
	if (crSearchDisplayAttributes.length != originalCrSearchDisplayAttributes.length)
	{
		return true;
	} 

	if (taskSearchDisplayAttributes.length != originalTaskSearchDisplayAttributes.length)
	{
		return true;
	}
	
	if (!areAllArrayValuesPresent(originalCrSearchDisplayAttributes, crSearchDisplayAttributes))
	{
		return true;
	}
	
	if (!areAllArrayValuesPresent(originalTaskSearchDisplayAttributes, taskSearchDisplayAttributes))
	{
		return true;
	}
	
	return false;
}

function areAllArrayValuesPresent(srcArray, newArray)
{	
	for (var i = 0; i < newArray.length; i++)
	{
		var foundValue = false;
		
		for (var j = 0; j < srcArray.length; j++)
		{
			if (newArray[i] == srcArray[j])
			{
				foundValue = true;
			}
		}
		
		if (!foundValue)
		{
			return false;
		}
	}
	
	return true;
}

function enableAdd()
{
	var attributeSelect = document.getElementById("sourceAttributes");
	
	if (attributeSelect.selectedIndex == -1)
	{
		document.getElementById("addButton").disabled = true;
	}
	else
	{
		document.getElementById("addButton").disabled = false;
	}
}

function enableSelectedButtons()
{
	var attributeSelect = document.getElementById("selectedAttributes");
		
	if (attributeSelect.selectedIndex == -1)
	{
		document.getElementById("removeButton").disabled = true;
		document.getElementById("upButton").disabled = true;
		document.getElementById("downButton").disabled = true;
	}
	else
	{
		var selectedValues = SelectUtils.getSelectedValues(document.getElementById("selectedAttributes"));
		var isProblemOrTaskNumberSelected = false;
		
		for (var i = 0; i < selectedValues.length; i++)
		{
			if ((selectedValues[i] == "problem_number")
			 || (selectedValues[i] == "task_number"))
			{
				isProblemOrTaskNumberSelected = true;
				break;
			}
		}
		
		if (isProblemOrTaskNumberSelected)
		{
			document.getElementById("removeButton").disabled = true;
		}
		else
		{
			document.getElementById("removeButton").disabled = false;
		}
		
		document.getElementById("upButton").disabled = false;
		document.getElementById("downButton").disabled = false;
	}
}

function add_onclick()
{
	var sourceSelect = document.getElementById("sourceAttributes");
	var selectedSelect = document.getElementById("selectedAttributes");
	
	var dirty = SelectUtils.copyOptions(sourceSelect, selectedSelect);
	
	if (dirty)
	{
		enableSelectedButtons();
		emphasizeApplyButton();
	}
}

function remove_onclick()
{
	var selectedSelect = document.getElementById("selectedAttributes");
	SelectUtils.removeSelected(selectedSelect);
	
	enableSelectedButtons();
	emphasizeApplyButton();
}

function up_onclick()
{
	SelectUtils.moveSelectedUp(document.getElementById("selectedAttributes"));
	emphasizeApplyButton();
}

function down_onclick()
{
	SelectUtils.moveSelectedDown(document.getElementById("selectedAttributes"));
	emphasizeApplyButton();
}

function emphasizeApplyButton()
{
	emphasizeButton(window.document.getElementById('apply'));
}

-->
	</script>

</head>

<body onload="initialize()">
<div style="padding-top: 5px; padding-bottom: 5px;">
	<b><change:resource key="adminSearchAttributeLabel"/></b>
</div>

<div style="margin: 5px; padding-bottom: 5px;">
	<change:resource key="searchAttributeInfo"/>
</div>

<center>
<div style="width: 50%">
	<div id="tabs">
		<ul id="tabsList" class="tabbedList">
			<li><a id="crTab" href="#" onclick="tab_onclick(this);" class="current"><change:resource key="lbl00762"/></a></li>
			<li><a id="taskTab" href="#" onclick="tab_onclick(this);"><change:resource key="lbl00032"/></a></li>
		</ul>
	</div>
	<table>
		<tr>
			<td>
				<label for="sourceAttributes" class="label_decoration">
					<change:resource key="lbl00194"/>
				</label>
			</td>
			<td>
				&nbsp;
			</td>
			<td>
				<label for="selectedAttributes" class="label_decoration">
					<change:resource key="lbl00195"/>
				</label>
			</td>
		</tr>
		<tr>
			<td>
				<select multiple id="sourceAttributes" size="15" onchange="enableAdd()"></select>
			</td>
			<td style="padding-left: 5px; padding-right: 5px;">
				<button id="addButton" class="columnButton" onclick="add_onclick()" disabled="disabled">
					<change:resource key="lbl00738"/>
				</button>
				<button id="removeButton" class="columnButton" onclick="remove_onclick()" disabled="disabled">
					<change:resource key="lbl00739"/>
				</button>
			</td>
			<td>
				<select multiple id="selectedAttributes" size="15" onchange="enableSelectedButtons()"></select>
			</td>
			<td valign="top" style="padding-left: 5px; padding-right: 5px;" nowrap>
				<button id="upButton" class="columnButton" onclick="up_onclick()" disabled="disabled">
					<change:resource key="lbl01112"/>
				</button>
				<button id="downButton" class="columnButton" onclick="down_onclick()" disabled="disabled">
					<change:resource key="lbl01113"/>
				</button>
			</td>
		</tr>
	</table>
</div>
</center>

<hr />

<div style="text-align: center; margin-bottom: 10px;">
	<button id="apply" type="button" onclick="save_onclick()" title="">
		<change:resource key="lbl00592"/>
	</button>
</div>

<form name="saveSearchAttributes" action="<change:urlCreator webResource='BASEURL'/>/adminSaveSearchAttributes.do" class="hiddenForm" method="POST" target="workspace">
	<input name="token" type="hidden" value="${user.token}" />
	<input name="regenerate" type="hidden" />
	<input name="crAttributes" type="hidden" />
	<input name="taskAttributes" type="hidden" />
</form>

</body>

</html>
