<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\admin_login.jsp -->
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>

<!-- admin_login.jsp page displays Login page for Admin users -->

<html:html locale="true">
	<head>
		<title><change:resource key="adminLoginTitle"/></title>
		<meta http-equiv="Content-Type" content="text/html; charset=<change:charEncoding/>">
		<style type="text/css">
			@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css";
			
			<change:wsletExpander>
				 <!-- WSLET CODE=PTInclude -->
				 <!-- PARAM NAME=styles/login.css -->
				 <!-- PARAM NAME=styles/passwordPolicy.css -->
				 <!-- /WSLET -->
			</change:wsletExpander>
		</style>

	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>loginScripts.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LoginUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LdapUserUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	<script type="text/javascript">
		dojo.require('dijit.Dialog');
	</script>
	<script type="text/javascript">
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=MessageFormat.js -->
			<!-- PARAM NAME=getWindowName.js -->
			<!-- PARAM NAME=browserDetect.js -->		 	
			<!-- /WSLET -->
		</change:wsletExpander>	
		<change:wsletExpander>
			 <!-- WSLET CODE=PTInclude -->
			 <!-- PARAM NAME=validation.js -->
			 <!-- PARAM NAME=EventUtils.js -->
			 <!-- PARAM NAME=passwordPolicy.js -->
			 <!-- PARAM NAME=dwrCallMetaData.js -->
			 <!-- /WSLET -->
		</change:wsletExpander>

		var dlg;
		var confirmdlg;
		var infodlg;
		var passwordPolicy;
		var tempPassword;
		
		/**
		 * On load function. Shows the login page.
		 */
		function loadLogin()
		{
			showLogin();

			EventUtils.addEvent(document.getElementById('newPassword'), 'keypress', ok_onKeypress);
			EventUtils.addEvent(document.getElementById('confirmPassword'), 'keypress', ok_onKeypress);	
		}

		/**
		 * Authenticates and Authorizes the user.
		 */
		function authenticate(e)
		{
			EventUtils.preventDefault(e);

			if (validateForm())
			{
				//display Authenticate message with 'spin' icon
				authenticating();
				
				//AJAX call to authenticate and authorize the Admin. 
				//The role 'Admin' is hardcoded and database passed is blank.
				LoginUtilsAjax.login(document.loginForm.userName.value, encodePassword(document.loginForm.password.value), 
					"Admin", "", DwrCall.getMetadata(authCallback, false, showLogin));
			}
		}

		/**
		 * AJAX callback function for login.
		 */
		function authCallback(loginResult)
		{
			document.loginForm.token.value = loginResult.token;

			if (!(loginResult.authSuccess))
			{
				showLogin();
				alert(loginResult.errorMessage);
				return false;
			}			
			else if (loginResult.passwordExpired || loginResult.daysToExpire > 0 || loginResult.passwordReset)
			{				
				tempPassword = document.loginForm.password.value;
				showPasswordExpiryMessage(loginResult);
				return;
			}			
			else
			{
				formSubmit();			
			}
		}

		/**
		 * Submit the form to show the Admin home page, after successful login.
		 */
		function formSubmit()
		{
			var token = document.loginForm.token.value;
		
			if (token != null)
			{
				if (!document.loginForm.isLaunchInCurrentWindowSet.checked)
				{
					var winName = getUniqueWindowName();
					var winOptions = '<change:wsletExpander>'
						+ '<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=ADMIN_WINDOW_OPTIONS --><!-- /WSLET -->'
						+ '</change:wsletExpander>';

					if (window.open("", winName, winOptions) == null)
					{
						alert("<change:resource key='unableToOpenNewWindow'/>");
						showLogin();
						return;
					}

					window.document.framesetForm.target = winName;
					window.document.framesetForm.token.value = token;
					
					BrowserDetect.doSubmitForm(window.document.framesetForm);
					document.loginForm.userName.value = "";
					resetLogin();
				}
				else
				{
					window.document.framesetForm.target = "_self";
					window.document.framesetForm.token.value = token;
					
					BrowserDetect.doSubmitForm(window.document.framesetForm);
				}
			}
			else
			{
				showLogin();
				alert('<change:resource key="noLoginAccess"/>');
			}
		}

		/**
		 * Validate the login form for user name and password.
		 */
		function validateForm()
		{
			if ((!hasNonWhiteSpaceChar(document.loginForm.userName.value)))		
			{
				alert('<change:resource key="userNameRequired"/>');
				document.loginForm.userName.focus();
				return false;
			}
			if ((!hasNonWhiteSpaceChar(document.loginForm.password.value)))		
			{
				alert('<change:resource key="passwordRequired"/>');
				document.loginForm.password.focus();
				return false;
			}
			return true;		
		}

		/**
		 * Show the login page.
		 */
		function showLogin()
		{
			resetLogin();
			document.loginForm.userName.focus();
			document.loginForm.userName.select();
		}
		
		/**
		 * Reset the login page but no focus back to the page
		 */
		function resetLogin()
		{
			document.loginForm.password.value = "";
			document.getElementById("loginBlock").style.display = "";
			document.getElementById("authenticating").style.display = "none";
			document.getElementById("launchInNewWindow").style.display = "";
			document.getElementById("gotoUserLogin").style.display = "";
		}

		/**
		 * Show 'spin' icon with message 'Authenticating'
		 */
		function authenticating()
		{
			document.getElementById("loginBlock").style.display = "none";
			document.getElementById("launchInNewWindow").style.display = "none";
			document.getElementById("gotoUserLogin").style.display = "none";
			document.getElementById("authenticating").style.display = "";
		}

		function openCookiePolicy()
		{
			var policyUrl = '<change:urlCreator webResource="PTWEB"/>'
				+ '?ACTION_FLAG=tokenless_form'
				+ '&TEMPLATE_FLAG=CookiePolicy';
				
			window.open(policyUrl, 'cookiePolicy', 'resizable,scrollbars,width=600,status').focus();
		}
		
		function openBrowserSupport()
		{
			var url = '<change:urlCreator webResource="PTWEB"/>'
				+ '?ACTION_FLAG=tokenless_form'
				+ '&TEMPLATE_FLAG=BrowserSupport';
				
			window.open(url, 'browserSupport', 'resizable,scrollbars,width=600,height=400,status').focus();
		}

		/** 
		 * Shows the password expiry or reset messages.
		 */		
		 var pwdAboutToExpire = false; 
		function showPasswordExpiryMessage(loginResult)
		{
			pwdAboutToExpire = false;
			var message = loginResult.errorMessage;
			var canChangePassword = loginResult.canUserChangePassword;
			var isPasswordExpired = loginResult.passwordExpired;
			var isPasswordReset = loginResult.passwordReset;
			passwordPolicy = loginResult.passwordPolicy;
			
			showLogin();
			writePasswordPolicy(document.getElementById("policyContent"), passwordPolicy);

			dlg = dijit.byId("popupDialog");

			if (!passwordPolicy.checkPasswordSyntax)
			{
				document.getElementById("policy").style.display = "none";
			}
			else
			{
				document.getElementById("policy").style.display = "";
			}
			
			confirmdlg = dijit.byId("pswdExpiryMsgDialog");
			infodlg = dijit.byId("infoDialog");
			
			if (isPasswordReset)	//password has been reset
			{
				if (canChangePassword)
				{
					document.getElementById("policyLabel").style.display = "";
					dojo.byId("pswdLblId").innerHTML = "<change:resource key='passwordResetLbl'/>";
					showPolicyDialog();
					return;
				}
				else
				{
					formSubmit();
				}
			}
			else if (isPasswordExpired)		//password has expired
			{
				//load the password updation page only if the user has rights to change password.
				if (canChangePassword)
				{
					document.getElementById("policyLabel").style.display = "";
					dojo.byId("pswdLblId").innerHTML = "<change:resource key='passwordExpireLbl'/>";
					showPolicyDialog();
					return;
				}
				else
				{
					dojo.byId("infoMsg").innerHTML = message;
					dojo.byId("pswdExpired").value = true;
					infodlg.show();
					document.getElementById("infoHider").focus();
					return;			
				}
			}
			else	//password has not expired yet
			{
				pwdAboutToExpire = true;
				if (canChangePassword)
				{
					//load the password updation page only if the user has rights to change password.
					dojo.byId("pswdExpiryMsg").innerHTML = message;
					confirmdlg.show();
					document.getElementById("pswdExpiryMsgDialogOk").focus();
					return;				
				}
				else	//If user has no rights to change password, show the message and process the login.
				{
					dojo.byId("infoMsg").innerHTML = message;
					dojo.byId("pswdExpired").value = false;
					infodlg.show();
					document.getElementById("infoHider").focus();
				}				
			}			
		}		
		
		function closeInfoDialog()
		{
			infodlg.hide();
			var pswdExpired = dojo.byId("pswdExpired").value;
			var token = document.loginForm.token.value;
			if (pswdExpired=='true')
			{
				showLogin();
			}
			else if (token != "null" && token.length > 0)
			{
				formSubmit();
			}
			else
			{
				alert('<change:resource key="noAdminRole"/>');
				showLogin();
			}			
		}
		
		function cancelPopupClose()
		{
			dlg.hide();	

			if (pwdAboutToExpire)
			{
				var token = document.loginForm.token.value;
				if (token != "null" && token.length > 0)
				{
					formSubmit();
				}
				else
				{
					alert('<change:resource key="noAdminRole"/>');
					showLogin();				
				}
			}
			else
			{
				showLogin();
			}
		}
		
		//If the modal dialog has been dimissed by the ok button, capture the changes.
		function okPopupClose()
		{
			var newPassword = dojo.byId("newPassword");
			var confirmPassword = dojo.byId("confirmPassword");
			var warningsSpan = dojo.byId("warnings");
			document.getElementById("warningMsgs").style.display = "";
			
			if (newPassword.value == '')
			{
				var msg = '<change:resource key="XfieldCannotBeEmpty"><change:param><change:resource key="newPassword"/></change:param></change:resource>';
				dojo.byId("warningIcon").style.display = "";
				warningsSpan.innerHTML = msg;
				newPassword.focus();
			}
			else if (confirmPassword.value == '')
			{
				var msg = '<change:resource key="XfieldCannotBeEmpty"><change:param><change:resource key="confirmPassword"/></change:param></change:resource>';
				dojo.byId("warningIcon").style.display = "";
				warningsSpan.innerHTML = msg;
				confirmPassword.focus();
			}			
			else if (newPassword.value != confirmPassword.value) 
			{
				warningsSpan.innerHTML = "<change:resource key='err00549'/>";
				dojo.byId("warningIcon").style.display = "";
				newPassword.value = "";
				confirmPassword.value = "";
				newPassword.focus();
			}
			else
			{
				var errorMsg = validatePassword(newPassword.value,passwordPolicy,false);
				
				if (errorMsg == "")
				{
					//Ajax call to change the user password.
					LdapUserUtilsAjax.changeUserPassword(document.loginForm.userName.value, 
						encodePassword(newPassword.value), encodePassword(tempPassword), 
						DwrCall.getMetadata(updatePasswordCallBack, updatePasswordFailureCallBack, false, false,
							function(){ dlg.hide() }));
				}
				else
				{
					warningsSpan.innerHTML = errorMsg;
					dojo.byId("warningIcon").style.display = "";
					newPassword.value = "";
					confirmPassword.value = "";
					newPassword.focus();
				}
			}					
		}

		/**
		* AJAX error callback function while updating a user's password.
		*/
		function updatePasswordFailureCallBack(errorMessage)
		{
			dlg.hide();
			alert(errorMessage);
			window.location.href = unescape("${applicationScope.contextRoot}" + "/admin.do");
		}

		/**
		 * Required function for XMLHttpRequest.js
		 *
		 */
		function updatePasswordCallBack(result)
		{
			eval(result);
		}

		function loginResult(errorMessage)
		{
			if (errorMessage != "")
			{
				dojo.byId("warnings").innerHTML = errorMessage;
				dojo.byId("warningIcon").style.display = "";
				dojo.byId("newPassword").value = "";
				dojo.byId("confirmPassword").value = "";
				dojo.byId("newPassword").focus();
			}
			else
			{
				dlg.hide();
				//after successful change of password, authenticate and authorize the user and log him in.
				LoginUtilsAjax.login(document.loginForm.userName.value, encodePassword(dojo.byId("newPassword").value), "Admin", "", authCallback);				
			}			
		}
		
		function resetPolicyDialog()
		{			
			dojo.byId("newPassword").value = "";
			dojo.byId("confirmPassword").value = "";
			dojo.byId("warnings").innerHTML = "";
			dojo.byId("warningIcon").style.display = "none";
		}
		
		function showPolicyDialog()
		{
			resetPolicyDialog();
			dlg.show();
			dojo.byId("newPassword").focus();
		}
		
		function pswdExpiryMsgDialogClose()
		{	
			confirmdlg.hide();
			var token = document.loginForm.token.value;
			if (token != "null" && token.length > 0)
			{
				formSubmit();
			}
			else
			{
				alert('<change:resource key="noAdminRole"/>');
				showLogin();
			}
		}
		
		function pswdExpiryMsgDialogOk()
		{
			confirmdlg.hide();
			showPolicyDialog();
		}
		
		function ok_onKeypress(evt)
		{
			if (evt.keyCode == 13)
			{
				okPopupClose();
			}
		}		
		
		dojo.addOnLoad(loadLogin);
	</script>	
	</head>

	<body class="bodyStyle">
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=custom_controls/password_model_dialog.CUSTOM -->
			<!-- PARAM NAME=SUB_SHOW_FORM VALUE=submit -->
			<!-- /WSLET -->
		</change:wsletExpander>

		<html:form action="admin.do" method="post">
			<table width="560px" border="0" cellspacing="0" cellpadding="0" class="login">
				<tr class="loginBlockStyleLarge">
					<td>
						<div class="loginBlockStyleNormal">

							<span style="font-weight: bold;"><change:resource key="adminLoginLabel"/></span>

							<c:set var="buildNumber">
								<change:wsletExpander>
									<!-- WSLET CODE=PTAdmin -->
										<!-- PARAM name=BUILD_NUMBER -->
									<!-- /WSLET -->
								</change:wsletExpander>
							</c:set>
							<change:resource key="release" bundle="52_patch">
								<change:param value="${buildNumber}"/>
							</change:resource>
						</div>
					</td> 
				</tr>

				<tr height="130px">
					<td>
						<table width="560px" border="0" class="padd">
							<tbody id="loginBlock">
								<tr>
									<td width="30%" align="right" valign="middle" class="bold">
										<label for="userName">
											<change:resource key="lbl00003"/>
										</label>
									</td>
									<td colspan="2" width="70%" align="left" valign="middle">
										<input style="width: 16em" id="userName" autocomplete="off" >
									</td>
								</tr>
	
								<tr>
									<td  width="30%" align=right valign="middle" class="bold">
										<label for="password">
											<change:resource key="lbl00004"/>
										</label>
									</td>
									<td  width="40%" align="left" valign="middle">
										<input style="width: 16em" type="password" name="password" id="password">
									</td>
									<td width="30%" align="left" valign="middle">
										<html:submit property="page" styleClass="button" onclick="authenticate(event)"><change:resource key="lbl00125"/></html:submit>
									</td>
								</tr>
							</tbody>
							<tr id="authenticating" style="display: none">
								<td colspan="3" align="center" valign="middle">
									<img src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">&nbsp;&nbsp;<change:resource key="authenticating"/>
								</td>
							</tr>
							<tr id="launchInNewWindow">
								<td width="30%"></td>
								<td align="left" colspan="2" valign="middle" class="launchInNewWindow">
									<html:checkbox property="isLaunchInCurrentWindowSet" styleId="isLaunchInCurrentWindowSet"></html:checkbox>
									<label for="isLaunchInCurrentWindowSet">
										<change:resource key="lbl00126"/>
									</label>
								</td>
							</tr>
							<tr id="gotoUserLogin">
								<td colspan="3" align="right" valign="top">
									<a href="user"><change:resource key="gotoUserLogin"/></a>&nbsp;&nbsp;
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>

			<html:hidden property="token"/>
		</html:form>
		<br/>
		<div class="footer">
			<a href="javascript: openBrowserSupport()"><change:resource key="info0109"/></a>
			|
			<a href="javascript: openCookiePolicy();"><change:resource key="cookiePolicyAction"/></a>
		</div>
		
		<form name="framesetForm" method="post" action="<change:urlCreator webResource='BASEURL'/>/framesetLoader.do">
			<input name="token" type="hidden">
			<input name="frameName" type="hidden" value="panelAndDialog">
		</form>
</body>
</html:html>
