<!-- forms\user_framework\add_home_page_reports.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<html>
<head>
	<title></title>

	<style type="text/css">
		@import "<change:urlCreator webResource='JS'/>dojo/resources/dojo.css";
		@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css";
		@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/tundra/tundra.css";

		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=styles/default.css -->
			<!-- PARAM NAME=styles/add_home_page_reports.css -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		div.dropzone
		{
			width: 99%;
			min-height: 30px;
			border: 1px dashed gray;
			text-align: center;
		}
		
		table.reportHandle 
		{
			background-color: rgb(225,238,255);
			cursor: move;
			margin: 3px;
			padding: 5px;
		}
		
		span.link
		{
			cursor: pointer;
			text-decoration: underline;
			color: blue;
		}
	</style>
	
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	
	<script type="text/javascript">
		dojo.require("dojo.dnd.common");
		dojo.require("dojo.dnd.Source");
		dojo.require("dijit.Tree");
		dojo.require("dijit._tree.dndSource");
		dojo.require("dojo.data.ItemFileReadStore");
		dojo.require("dojo.fx");			
	</script>
	
	<script type="text/javascript">
		dojo.registerModulePath("custom", "../../customDojo");
		
		dojo.require("custom.AddHomePageAvatar");
		dojo.require("custom.AddHomePageSource");
		dojo.require("custom.AddHomePageTree");
	</script>
	
	<script type="text/javascript">	
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=domUtilities.js -->
			<!-- PARAM NAME=subhelp.js -->
			<!-- PARAM NAME=emphasis.js -->
			<!-- PARAM NAME=note.js -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		var isModified = false;

		<c:if test="${not empty editHomePage}">
			var editHomePage = new Object();
			editHomePage.name = <change:javaScriptEscape value="${editHomePage.name}"/>;
			editHomePage.adminDefined = <change:javaScriptEscape value="${editHomePage.adminDefined}"/>;
			editHomePage.reports = new Array();
			<c:forEach items="${editHomePage.homePageReports}" var="reportItem" varStatus="status">
			editHomePage.reports[${status.index}] = new Object();
			editHomePage.reports[${status.index}].name = <change:javaScriptEscape value="${reportItem.name}"/>;
			editHomePage.reports[${status.index}].dropArea = <change:javaScriptEscape value="${reportItem.dropArea}"/>;
			editHomePage.reports[${status.index}].sortPosition = <change:javaScriptEscape value="${reportItem.sortPosition}"/>;
			editHomePage.reports[${status.index}].configType = <change:javaScriptEscape value="${reportItem.configType}"/>;
			</c:forEach>
		</c:if>
		
		dojo.addOnLoad(function()
		{	
			// Text selection is default behavior in IE, this looks very odd 
			// while user does drag and drop. So disabling text selection for IE.
			// No such issues in FF. 
			if (dojo.isIE) document.onselectstart = function() 
			{
				return false;
			}
			
			dojo.subscribe("/dnd/drop", function(source)
			{
				// If a folder from tree is dragged then donot mark as unsaved.								
				if (source.tree)
				{
					var items = source.getSelectedItems();
					var store = source.tree.model.store;
					var hasFolder = false;
					
					for (var i = 0; i < items.length ; ++i)
					{				
						if (items[i].root || (store.getValue(items[i], "type") == "folder"))
						{
							hasFolder = true;
							break;
						}
					} 
					
					if (!hasFolder)
					{
						markUnSaved();
					}
					
					return;
				}
				
				// For Source and Target just mark as unsaved.
				markUnSaved();
			});
			
			dojo.connect("removeElement", "markUnSaved");
			
			<c:if test="${((editMode == 'true') and (not empty editHomePage))}">
				editMode();
			</c:if>			
		});
		
		function markUnSaved()
		{
			var button = dojo.byId("saveButton");
			emphasizeButton(button);
			window.isModified = true;
		}
		
		function hasModifications()
		{
			return window.isModified;
		}
		
		function editMode()
		{
			var length = editHomePage.reports.length;
			
			for (var i = 0; i < length; i++)
			{
				var objNode = {
					reportName: editHomePage.reports[i].name,
					configType: editHomePage.reports[i].configType				
				}
				
				var div = createReportDiv(objNode);
				var dropArea = dojo.byId(editHomePage.reports[i].dropArea);
				
				if (dropArea == undefined)
				{
					dropArea = dojo.byId("drop1");
				}
				
				dropArea.appendChild(div);
			}
		}
		
		// TODO: encapsulate it in some class. Since jsp tags or wslets are not parsed
		// when we do a dojo.require() on class, find a way to to do so.
		function createReportDiv(objNode)
		{
			var div = document.createElement("div");
			div.className = "dojoDndItem";							
			div.id = "report_" + dojo.dnd.getUniqueId();
			div.report = {name: objNode.reportName, configType: new String(objNode.configType)};
			
			var table = document.createElement("table");
			table.width = "100%"
			table.className = "reportHandle";
			table.cellSpacing = "0";
			table.cellPadding = "0";
			table.border = "0";
			
			var tableBody = document.createElement("tbody");
			var tr = document.createElement("tr");
		
			var td = document.createElement("td");
			var text = document.createTextNode(objNode.reportName);
			td.appendChild(text);
			tr.appendChild(td);
			
			var td2 = document.createElement("td");
			td2.style.textAlign = "right";
		
			var spanDelete = document.createElement("span");
			spanDelete.innerHTML = '<change:resource key="lbl01155"/>';
			spanDelete.className = "link";	
			spanDelete.onclick = function()
			{
				removeElement(div.id);
			};
		
			td2.appendChild(spanDelete);							
			tr.appendChild(td2);
			
			tableBody.appendChild(tr);
			table.appendChild(tableBody);
			div.appendChild(table);
			
			return div;
		}
		
		function removeElement(elementId)
		{
			var element = document.getElementById(elementId);
			var parent = element.parentNode;	
			parent.removeChild(element);
		}
		
		function saveOnClick()
		{
			var homePage = new Object();
			homePage.name = <change:javaScriptEscape value="${param.homePageTitle}"/>;
			homePage.pageLayout = "${param.pageLayout}";
			homePage.specifyColumnWidths = "${param.specifyColumnWidths}";
			homePage.firstColWidth = "${param.firstColWidth}";
			homePage.secondColWidth = "${param.secondColWidth}";
			homePage.adminDefined = "${asAdmin}";
			
			var foundAReport = false;
			
			//For each potential drop area (max of 4)
			for (var i = 1; i <= 4; i++)
			{
				var currentDropArea = "drop" + i;
				var dropArea = document.getElementById(currentDropArea);
			
				if (!dropArea)
				{
					continue;
				}
				
				//Create a new array for the drop zone.
				homePage[currentDropArea] = new Array();
				
				var length = dropArea.childNodes.length;
				var current = 0;
				
				for (var x = 0; x < length; x++)
				{
					var child = dropArea.childNodes[x];
					
					if (child.id && (child.id.match(/^report.*/i) != null))
					{
						foundAReport = true;
						homePage[currentDropArea][current] = new Object();
						homePage[currentDropArea][current].name = unescape(child.report.name);
						homePage[currentDropArea][current].configType = child.report.configType;
						current++;
					}
				}
			}
			
			if (!foundAReport)
			{
				alert("<change:resource key="oneReportRequired"/>");
				return;	
			}
			
			window.document.createHomePage.token.value = "${user.token}";
			window.document.createHomePage.actionFlag.value = "saveHomePage";
			window.document.createHomePage.homePageAsJSON.value = dojo.toJson(homePage);
			<c:if test="${not empty editHomePage}">
				window.document.createHomePage.originalName.value = editHomePage.name;
			</c:if>
			
			window.document.createHomePage.submit();
		}
		
		// Data for creation of Tree.
		var crStore = new dojo.data.ItemFileReadStore({data: ${crAdHocReports}});

		<c:if test="${not empty taskAdHocReports}">
			var taskStore = new dojo.data.ItemFileReadStore({data: ${taskAdHocReports}});
		</c:if>
	</script>	
</head>

<body class="tundra">
	<table width="100%" class="barHeading">
		<tr>
			<th>
				<c:choose>
					<c:when test="${editMode == 'true'}">
						<change:resource key='editExistingHomePage'/>
					</c:when>
					<c:otherwise>
						<c:choose>
							<c:when test="${asAdmin}">
								<change:resource key='createDefaultHomePage'/>
							</c:when>
							<c:otherwise>
								<change:resource key='addHomePage'/>
							</c:otherwise>			
						</c:choose>
					</c:otherwise>
				</c:choose>
				<span id="name">&nbsp;&#151;&nbsp;<change:resource key='addReportsToHomePage'/></span>
			</th>
			<th style="text-align: right;">
				<c:choose>
					<c:when test="${asAdmin}">
						<a href="javascript:openHelp('${user.role}', 37)" title="<change:resource key='homePageHelp'/>"><change:resource key="lbl01070"/></a>
					</c:when>
					<c:otherwise>
						<a href="javascript:openHelp('${user.role}', 34)" title="<change:resource key='homePageHelp'/>"><change:resource key="lbl01070"/></a>
					</c:otherwise>
				</c:choose>
			</th>
		</tr>
	</table>
	
	<table width="100%">
		<tr>
			<td width="38%" valign="top">
				<table width="95%">
					<tr>
						<td>
							<label class="label_decoration"><change:resource key='availableReports'/></label>&nbsp;<i>(<change:resource key='drag'/>)</i>
							
							<div style="padding: 10px; margin: 5px; border: 1px solid gray;">
								<div id="crTree" dojoType="dijit.Tree" store="crStore" labelAttr="name"
									label="<change:resource key='Problem_Identifier_Plural'/>" jsid="popStore" isExpandable="false"
									dndController="dijit._tree.dndSource">
									<script	type="dojo/method" event="checkAcceptance" args="source, nodes">
										// Always return false so that tree remains static
										return false;
									</script>
			
									<script type="dojo/method" event="checkItemAcceptance" args="nodes, source">
										// Always return false so that tree remains static
										return false;
									</script>
								</div>										
								
								<c:if test="${not empty taskAdHocReports}">
									<div id="taskTree" dojoType="dijit.Tree" store="taskStore" labelAttr="name"
										label="<change:resource key='lbl00032'/>" jsid="popStore" isExpandable="false"
										dndController="dijit._tree.dndSource">
										<script	type="dojo/method" event="checkAcceptance" args="source, nodes">
											// Always return false so that tree remains static
											return false;
										</script>
				
										<script type="dojo/method" event="checkItemAcceptance" args="nodes, source">
											// Always return false so that tree remains static
											return false;
										</script>
									</div>										
								</c:if>
							</div>
						</td>
					</tr>
				<tr>
					<td>
						<div class="expandableNote">
							<div class="noteTitle">
								<change:resource key='homePageAdhocTitle'/>
							</div>
							<div class="noteText">
								<change:resource key='homePageAdhocExpand'/>
							</div>
						</div>
					</td>			
				</tr>
				</table>
			</td>
			
			<td width="62%" valign="top">
				<table width="95%">
					<tr>
						<td>
							<label class="label_decoration"><change:resource key='homePageReports'/></label>&nbsp;<i>(<change:resource key='drop'/>)</i>				
							<div style="border: 1px solid gray; margin: 5px; padding: 5px; width: 100%;">
								<table width="100%">
									<tr>
										<th style="background-color:#DDD; text-align: left; padding-left: 5px; margin-bottom: 10px;">
											<c:out value="${param.homePageTitle}"></c:out>
										</th>
									</tr>
								</table>
								<c:if test="${param.specifyColumnWidths == 'true'}" var="specifyColumnWidths"/>
											
								<table width="100%" cellspacing="0" cellpadding="5">
									<c:choose>
										<c:when test="${param.pageLayout == 'singleRow'}">
											<tr>
												<td>
													<div id="drop1" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">											
													</div>										
												</td>	
											</tr>
										</c:when>
										<c:when test="${param.pageLayout == 'dualColumn'}">
											<tr>
												<td valign="top" width="50%">
													<div id="drop1" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>
												<td valign="top" width="50%">
													<div id="drop2" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>
											</tr>
										</c:when>
										<c:when test="${param.pageLayout == 'rowDualColumn'}">
											<tr>
												<td colspan="2" style="padding-right: 2px;">
													<div id="drop1"dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>	
											</tr>
											<tr>
												<td valign="top" width="50%">
													<div id="drop2" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>
												<td valign="top" width="50%">
													<div id="drop3" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>
											</tr>
										</c:when>
										<c:when test="${param.pageLayout == 'dualColumnRow'}">							
											<tr>
												<td valign="top" width="50%">
													<div id="drop1" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>
												<td valign="top" width="50%">
													<div id="drop2" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>
											</tr>
											<tr>
												<td valign="top" colspan="2" style="padding-right: 2px;">
													<div id="drop3" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>	
											</tr>
										</c:when>
										<c:when test="${param.pageLayout == 'twoRowDualColumn'}">
											<tr>
												<td colspan="2" style="padding-right: 2px;">
													<div id="drop1" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>	
											</tr>						
											<tr>
												<td valign="top" width="50%">
													<div id="drop2" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>
												<td valign="top" width="50%">
													<div id="drop3" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>
											</tr>
											<tr>
												<td colspan="2" style="padding-right: 2px;">
													<div id="drop4" dojoType="dojo.dnd.Source" 
														checkAcceptance="return true;" accept='*' class="dropZone">
													</div>
												</td>	
											</tr>
										</c:when>
									</c:choose>
								</table>
							</div>						
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
	
	<hr>
	<div style="text-align: center">
		<button id="saveButton" onclick="saveOnClick()"><change:resource key='lbl00592'/></button>
	</div>
	
	<form name="createHomePage" action="<change:urlCreator webResource='BASEURL'/>/createHomePage.do" class="hiddenForm" method="POST" target="_self">
		<input name="token" type="hidden">
		<input name="actionFlag" type="hidden">
		<input name="homePageAsJSON" type="hidden">
		<input name="asAdmin" type="hidden" value="${asAdmin}">
		<input name="editMode" type="hidden" value="${editMode}">
		<c:if test="${not empty editHomePage}">
			<input name="originalName" type="hidden">
		</c:if>
	</form>	
</body>
</html>
