<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\user_login.jsp -->
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change"%>

<!-- user_login.jsp page is the Login page for Non-Admin users -->

<html:html locale="true">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=<change:charEncoding/>">
		<title><change:resource key="userLoginTitle"/></title>
		<style type="text/css">
			@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css";
		
			<change:wsletExpander>
				<!-- WSLET CODE=PTInclude -->
					<!-- PARAM NAME=styles/login.css -->
					<!-- PARAM NAME=styles/passwordPolicy.css -->
				<!-- /WSLET -->
			</change:wsletExpander>			
		</style>		

	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>loginScripts.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LoginUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LdapUserUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	<script type="text/javascript">
		dojo.require('dijit.Dialog');
		dojo.require('dojo.cookie');
	</script>

	<script type="text/javascript">
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=MessageFormat.js -->
			<!-- PARAM NAME=getWindowName.js -->
			<!-- PARAM NAME=browserDetect.js -->
			<!-- PARAM NAME=dwrCallMetaData.js -->
			<!-- /WSLET -->
		</change:wsletExpander>

		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=validation.js -->
			<!-- PARAM NAME=EventUtils.js -->
			<!-- PARAM NAME=passwordPolicy.js -->
			<!-- /WSLET -->
		</change:wsletExpander>

		var dbAndRolesList="";

		var dlg;
		var confirmdlg;
		var infodlg;
		var passwordPolicy;
		var isCookieBoxChecked = false;
		var tempPassword;
		var loginCookieName = "ChangeLoginCookie_" + window.location.port;
		var cookieValues;
		var cookieRole = "User";
		var userRole = "User";

		/**
		 * On load function. Shows the login page.
		 * For the Login, a Cookie named "ChangeLoginCookie_<port>" is maintained.
		 * It will contain user name, database name, database alias, role, isLaunchInCurrentWindowSet information.
		 * All the 5 values are in order and are separated by pipe("|") symbol.
		 * Setting and retriving this cookie is done in the JavaScript.
		 */
		function loadLogin()
		{
			retrieveCookieValues();
			showLogin();

			EventUtils.addEvent(document.loginForm.userName, 'keypress', loginFields_onKeyup);
			EventUtils.addEvent(document.loginForm.password, 'keypress', loginFields_onKeyup);
			EventUtils.addEvent(document.loginForm.isLaunchInCurrentWindowSet, 'keypress', loginFields_onKeyup);
			EventUtils.addEvent(document.getElementById("cookieBlock"), 'keypress', loginFields_onKeyup);
			EventUtils.addEvent(document.getElementById('newPassword'), 'keypress', ok_onKeypress);
			EventUtils.addEvent(document.getElementById('confirmPassword'), 'keypress', ok_onKeypress);						
		}

		function retrieveCookieValues()
		{
			var isCookiePopulated = populateCookie();
			
			if(isCookiePopulated)
			{
				document.getElementById("cookieBlock").style.display = "";
				document.loginForm.isCookiePresent.checked = true;	
			}
			else
			{
				document.getElementById("cookieBlock").style.display = "none";
				document.loginForm.isCookiePresent.checked = false;
			}

			document.getElementById("launchInNewWindow").style.display = "";
		}
		
		function populateCookie()
		{
			cookieValues = dojo.cookie(loginCookieName);

			if (cookieValues != null)
			{
				cookieValues = unescape(cookieValues);
			}
			else
			{
				return false;
			}		

			var values = cookieValues.split("|");

			if (values.length == 5)
			{
				document.loginForm.userName.value = values[0];			
				document.loginForm.databaseAlias.value = values[2];
				var cookieMessage = '<change:resource key="userDBandRole"><change:param><b>'+values[2]+'</b></change:param><change:param><b>'+values[3]+'</b></change:param></change:resource>';
				document.getElementById("cookieValue").innerHTML = cookieMessage;
	
				document.loginForm.database.value = values[1];
				document.loginForm.role.value = values[3];
				cookieRole = values[3];

				if (values[4]=='true')
				{
					document.loginForm.isLaunchInCurrentWindowSet.checked = true;
					isCookieBoxChecked = true;
				}
				else
				{
					document.loginForm.isLaunchInCurrentWindowSet.checked = false;
					isCookieBoxChecked = false;
				}
				
				return true;
			}
			else
			{	
				return false;
			}
		}		

		/**
		 * Authenticates the user.
		 */
		function authenticate(e)
		{
			EventUtils.preventDefault(e);
		
			if (!validateForm())
			{
				return false;
			}

			//display Authenticate message with 'spin' icon
			authenticating();
			//AJAX call to authenticate the user and fetch his databases and roles.
			LoginUtilsAjax.preLogin(document.loginForm.userName.value, encodePassword(document.loginForm.password.value),
				DwrCall.getMetadata(preLoginAuthCallback, false, showLogin));			
		}

		/**
		 * AJAX callback function for preLogin.
		 */
		function preLoginAuthCallback(loginResult)
		{
			dbAndRolesList = loginResult.databaseAndRole;
			tempPassword = document.loginForm.password.value;
		
			if (!(loginResult.authSuccess))
			{				
				if (!loginResult.preLoginCheckSuccess)
				{
					alert(loginResult.errorMessage);
					//refresh the page
					window.location.href = unescape("${applicationScope.contextRoot}" + "/user");
				}
				else
				{
					showLogin();
					alert(loginResult.errorMessage);
				}
			}
			else if (loginResult.passwordExpired || loginResult.daysToExpire > 0 || loginResult.passwordReset)
			{
			
				showPasswordExpiryMessage(loginResult);
				return;
			}			
			else
			{
				checkForCookieBeforeLogin();			
			}
		}
		
		/**
		 * Check the user cookie and validate the cookie before login
		 */
		function checkForCookieBeforeLogin()
		{
			if (document.loginForm.isCookiePresent.checked)
			{
				if (dbAndRolesList.length == 0)
				{
					showLogin();
					document.loginForm.isCookiePresent.checked = false;
					alert('<change:resource key="noLoginAccess"/>');
					return;
				}
				else if (validateCookie())
				{
					login();
				}
				else
				{
					showLogin();
					alert('<change:resource key="invalidDbAndRole"/>');
					rolesAndDbs();
				}
			}
			else
			{
				rolesAndDbs();
			}	
		}
		
		/**
		 * AJAX call for user login.
		 */
		function login()
		{
			showConnectingMsg();
			LoginUtilsAjax.login(document.loginForm.userName.value, encodePassword(tempPassword), document.loginForm.role.value,
				document.loginForm.database.value, DwrCall.getMetadata(loginAuthCallback, false, showLogin));
		}
		
		/**
		 * AJAX callback function for user login.
		 */
		function loginAuthCallback(loginResult)
		{		
			if (loginResult.token == null)
			{
				if (loginResult.databaseAndRole != null)
				{
					dbAndRolesList = loginResult.databaseAndRole;
				}
				
				alert(loginResult.errorMessage);
				rolesAndDbs();
				
				/* If authentication fails, page has to be refreshed. */
				if (!loginResult.isAuthSuccess)
				{
					//refresh the page
					window.location.reload(true);
				}
			}
			else
			{
				document.loginForm.token.value = loginResult.token;
				formSubmit();
			}
		}

		/**
		* Validate cookie for valid database and role.
		*/
		function validateCookie()
		{
			var cookieValidation = false;
			var validateRole = false;
			var validateDatabase = false;

			for (i=0; i < dbAndRolesList.length; i++)
			{
				var roleList = dbAndRolesList[i].webRolesList;
				if (roleList.length > 0)
				{
					for (k=0; k<roleList.length; k++)
					{
						if (roleList[k] == document.loginForm.role.value)
						{
							validateRole = true;
						}
					}
				}
				if (dbAndRolesList[i].databaseName == document.loginForm.database.value)
				{
					validateDatabase = true;
				}
			}

			if (validateRole && validateDatabase)
			{
				cookieValidation = true;
			}

			return cookieValidation;
		}

		/**
		 * Submit the form to show the user home page, after successful login.
		 */
		function formSubmit()
		{
			var token = document.loginForm.token.value;

			if (token != null)
			{
				setCookie();		

				window.document.framesetForm.isLaunchInCurrentWindowSet.value = document.loginForm.isLaunchInCurrentWindowSet.checked;
				window.document.framesetForm.userName.value = document.loginForm.userName.value;
				window.document.framesetForm.database.value = document.loginForm.database.value;
				window.document.framesetForm.role.value = document.loginForm.role.value;

				if (!document.loginForm.isLaunchInCurrentWindowSet.checked)
				{
					var winName = getUniqueWindowName();
					var winOptions = '<change:wsletExpander>'
						+ '<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=USER_WINDOW_OPTIONS --><!-- /WSLET -->'
						+ '</change:wsletExpander>';

					if (window.open("", winName, winOptions) == null)
					{
						alert("<change:resource key='unableToOpenNewWindow'/>");
						retrieveCookieValues();
						showLogin();
						return;
					}

					window.document.framesetForm.target = winName;
					window.document.framesetForm.token.value = token;
					
					BrowserDetect.doSubmitForm(window.document.framesetForm);
					retrieveCookieValues();
					resetLogin();
				}
				else
				{
					window.document.framesetForm.target = "_self";
					window.document.framesetForm.token.value = token;
					BrowserDetect.doSubmitForm(window.document.framesetForm);
				}
			}
			else
			{
				alert('<change:resource key="noLoginAccess"/>');
				showLogin();
			}
		}
		
		function setCookie()
		{
			cookieValues = document.loginForm.userName.value  + "|" + document.loginForm.database.value + "|" +document.loginForm.databaseAlias.value + "|" + document.loginForm.role.value + "|" + document.loginForm.isLaunchInCurrentWindowSet.checked;
			dojo.cookie(loginCookieName, cookieValues, { expires: 365, path: "/" });
		}

		/**
		 * Populate roles and database list boxes for the user to select.
		 */
		function rolesAndDbs()
		{
			var isAccessible = "false";

			if (dbAndRolesList.length == 0)
			{
				showLogin();
				alert('<change:resource key="noLoginAccess"/>');
				return;
			}
			else
			{
				for (i=0; i < dbAndRolesList.length; i++)
				{
					if (dbAndRolesList[i].webRolesList.length > 0)
					{
						isAccessible = "true";
						break;
					}
				}

				if (isAccessible == "false")
				{
					showLogin();
					alert('<change:resource key="noLoginAccess"/>');
					return;
				}
			}

			var selectOptionString = "";

			if (dbAndRolesList.length == 1)
			{
				selectOptionString += dbAndRolesList[0].databaseAlias;
				selectOptionString += '<input type=hidden name="database" value='+dbAndRolesList[0].databaseName+'>';
				document.getElementById("dbOptions").innerHTML=selectOptionString;	
			}
			else
			{
				selectOptionString += '<select name="database" id="dbList" onchange="populateRolesList()">';

				for (i = 0; i < dbAndRolesList.length; i++)
				{
					var dbName = dbAndRolesList[i].databaseAlias;
					
					if (${isCentralServer} && dbAndRolesList[i].central)
					{
						dbName = '<change:resource key="centralCrDatabaseLbl"><change:param>' + dbAndRolesList[i].databaseAlias + '</change:param></change:resource>';						
					}						
					
					selectOptionString += '<option value='+dbAndRolesList[i].databaseName+'>' + dbName + ' ' + dbAndRolesList[i].statusInDisplayFormat + '</option>';

				}

				selectOptionString += '</select>';
				document.getElementById("dbOptions").innerHTML=selectOptionString;
			}

			populateRolesList();
			dbRolesList();			
		}

		function populateRolesList()
		{
			if (${isCentralServer})
			{
				if (document.getElementById("roleList"))
				{
					cookieRole = document.loginForm.role.value;
				}
			}
			
			var selectRolesString = "";
			var index = 0;

			if (dbAndRolesList.length > 1)
			{
				index = document.getElementById("dbList").options.selectedIndex;			
			}

			document.loginForm.databaseAlias.value = dbAndRolesList[index].databaseAlias;

			var rolesList = dbAndRolesList[index].webRolesList;

			if (rolesList.length == 1)
			{
				selectRolesString += rolesList[0];
				selectRolesString += '<input type=hidden name="role" value='+rolesList[0]+'>';
				document.getElementById("roleOptions").innerHTML=selectRolesString;	
			}
			if (rolesList.length > 1)
			{
				populateDefaultRole(rolesList);
				selectRolesString += '<select name="role" id="roleList">';
				for (k=0;k<rolesList.length;k++)
				{
					if (rolesList[k] == cookieRole)
					{
						selectRolesString += '<option selected="selected" value='+rolesList[k]+'>'+rolesList[k]+'</option>';
					}
					else
					{
						selectRolesString += '<option value='+rolesList[k]+'>'+rolesList[k]+'</option>';
					}
				}
				selectRolesString += '</select>';
				document.getElementById("roleOptions").innerHTML=selectRolesString;	
			}			

			return;
		}

		/**
		* Populate Default Role. 
		* If the user has a role value stored in their cookie, 
		* and that role is still valid (i.e., in the list), it 
		* shall be selected. Otherwise, if the user has the User role, it shall be selected. 
		* Failing that, the first role in the list shall be selected.
		*/
		function populateDefaultRole(rolesList)
		{
			var isUserRoleExists = false;
			
			for(i=0;i<rolesList.length;i++)
			{
				if (rolesList[i] == cookieRole)
				{
					return;
				}
				else if (rolesList[i] == userRole)
				{
					isUserRoleExists = true;
				}
			}
			
			if (isUserRoleExists)
			{
				cookieRole = userRole;
			}
			else
			{
				cookieRole = rolesList[0];
			}
		}
		
		
		/**
		 * Validate the login form for user name and password.
		 */
		function validateForm()
		{
			if ((!hasNonWhiteSpaceChar(document.loginForm.userName.value)))
			{
				alert('<change:resource key="userNameRequired"/>');
				document.loginForm.userName.focus();
				return false;
			}
			if ((!hasNonWhiteSpaceChar(document.loginForm.password.value)))
			{
				alert('<change:resource key="passwordRequired"/>');
				document.loginForm.password.focus();
				return false;
			}

			return true;
		}

		/**
		 * Show the user login page.
		 */
		function showLogin()
		{
			resetLogin();
			document.loginForm.userName.focus();
			document.loginForm.userName.select();
		}
		
		/**
		 * Reset the login page but no focus back to the page
		 */		
		function resetLogin()
		{
			document.loginForm.password.value = "";		
			document.getElementById("connecting").style.display = "none";	
			document.getElementById("loginBlock").style.display = "";
			document.getElementById("authenticating").style.display = "none";
			document.getElementById("dbAndRolesList").style.display = "none";
			
			if (isCookieBoxChecked)
			{
				document.loginForm.isCookiePresent.checked = true;	
			}

			if (cookieValues != null && cookieValues.length > 0)
			{
				document.getElementById("cookieBlock").style.display = "";
			}
			else
			{
				document.getElementById("cookieBlock").style.display = "none";
			}

			document.getElementById("launchInNewWindow").style.display = "";
		}

		/**
		 * Show 'spin' icon with message 'Authenticating'
		 */
		function authenticating()
		{
			document.getElementById("loginBlock").style.display = "none";
			document.getElementById("authenticating").style.display = "";
			document.getElementById("launchInNewWindow").style.display = "none";
			document.getElementById("cookieBlock").style.display = "none";
		}
		
		/**
		 * Show 'spin' icon with message 'Connecting'
		 */
		function showConnectingMsg()
		{
			document.getElementById("authenticating").style.display = "none";
			document.getElementById("dbAndRolesList").style.display = "none";			
			document.getElementById("connecting").style.display = "";
			
			// After successfully changing the password through the password reset dialog, 
			// hide the following elements also.
			document.getElementById("loginBlock").style.display = "none";
			document.getElementById("cookieBlock").style.display = "none";
			document.getElementById("launchInNewWindow").style.display = "none";
		}

		function dbRolesList()
		{
			document.getElementById("loginBlock").style.display = "none";
			document.getElementById("authenticating").style.display = "none";
			document.getElementById("cookieBlock").style.display = "none";
			document.getElementById("launchInNewWindow").style.display = "none";
			document.getElementById("dbAndRolesList").style.display = "";
			EventUtils.addEvent(document.loginForm.isLaunchInCurrentWindowSet, 'keypress', login_onKeyup);

			var dbList = document.getElementById("dbList");
			var roleList = document.getElementById("roleList");

			if (roleList)
			{
				roleList.focus();
				EventUtils.addEvent(roleList, 'keypress', login_onKeyup);
			}

			if (dbList)
			{
				dbList.focus();
				EventUtils.addEvent(dbList, 'keypress', login_onKeyup);
			}

			if (!(dbList || roleList))
			{
				document.loginForm.connectButton.focus();
			}

			return false;
		}
		
		function loginFields_onKeyup(evt)
		{
			if (evt.keyCode == 13)
			{
				authenticate(evt);
			}
		}
		function login_onKeyup(evt)
		{
			if (evt.keyCode == 13)
			{
				login();
			}
		}
		
		function openCookiePolicy()
		{
			var policyUrl = '<change:urlCreator webResource="PTWEB"/>'
				+ '?ACTION_FLAG=tokenless_form'
				+ '&TEMPLATE_FLAG=CookiePolicy';

			window.open(policyUrl, 'cookiePolicy', 'resizable,scrollbars,width=600,status').focus();
		}

		function openBrowserSupport()
		{
			var url = '<change:urlCreator webResource="PTWEB"/>'
				+ '?ACTION_FLAG=tokenless_form'
				+ '&TEMPLATE_FLAG=BrowserSupport';

			window.open(url, 'browserSupport', 'resizable,scrollbars,width=600,height=400,status').focus();
		}

		/**
		 * Shows the password expiry or reset messages.
		 */
		 var pwdAboutToExpire = false; 
		function showPasswordExpiryMessage(loginResult)
		{
			pwdAboutToExpire = false;
			var message = loginResult.errorMessage;
			var canChangePassword = loginResult.canUserChangePassword;
			var isPasswordExpired = loginResult.passwordExpired;
			var isPasswordReset = loginResult.passwordReset;
			passwordPolicy = loginResult.passwordPolicy;
			
			isCookieBoxChecked = document.loginForm.isCookiePresent.checked;
			showLogin();
		
			writePasswordPolicy(document.getElementById("policyContent"), passwordPolicy);
			dlg = dijit.byId("popupDialog");

			if (!passwordPolicy.checkPasswordSyntax)
			{
				document.getElementById("policy").style.display = "none";
			}
			else
			{
				document.getElementById("policy").style.display = "";
			}

			confirmdlg = dijit.byId("pswdExpiryMsgDialog");

			infodlg = dijit.byId("infoDialog");

			//var infoBtn = document.getElementById("infoHider");
			//infodlg.setCloseControl(infoBtn);
			
			if (isPasswordReset)	//password is reset
			{
				if (canChangePassword)
				{
					document.getElementById("policyLabel").style.display = "";
					var pswdResetLblSpan = dojo.byId("pswdLblId");
					pswdResetLblSpan.innerHTML = "<change:resource key='passwordResetLbl'/>";
					showPolicyDialog();
					return;
				}
				else
				{
					checkForCookieBeforeLogin();
				}
			}
			else if (isPasswordExpired)		//password is expired
			{
				//load the password updation page only if the user has rights to change password.
				if (canChangePassword)
				{
					document.getElementById("policyLabel").style.display = "";
					dojo.byId("pswdLblId").innerHTML = "<change:resource key='passwordExpireLbl'/>";
					showPolicyDialog();
					return;
				}
				else
				{
					dojo.byId("infoMsg").innerHTML = message;
					dojo.byId("pswdExpired").value = true;
					infodlg.show();
					document.getElementById('infoHider').focus();
				}
			}
			else	//password is not expired yet
			{
				pwdAboutToExpire = true;
				if (canChangePassword)
				{
					//load the password updation page only if the user has rights to change password.
					dojo.byId("pswdExpiryMsg").innerHTML = message;
					confirmdlg.show();					
					document.getElementById("pswdExpiryMsgDialogOk").focus();
					return;
				}
				else	//If user has no rights to change password, show the message and process the login.
				{
					dojo.byId("infoMsg").innerHTML = message;
					dojo.byId("pswdExpired").value = false;
					infodlg.show();
					document.getElementById('infoHider').focus();
				}
			}
		}

		function closeInfoDialog()
		{
			infodlg.hide();
			
			var pswdExpired = dojo.byId("pswdExpired").value;
			
			if (pswdExpired=='true')
			{
				showLogin();
			}
			else
			{
				checkForCookieBeforeLogin();
			}
			
		}
		function cancelPopupClose()
		{
			dlg.hide();			
			
			if (pwdAboutToExpire)
			{
				checkForCookieBeforeLogin();
			}
			else
			{
				showLogin();
			}
		}

		//The modal dialog has been dimissed by clicking the ok button, capture the changes.
		function okPopupClose()
		{
			var newPassword = dojo.byId("newPassword");
			var confirmPassword = dojo.byId("confirmPassword");
			var warningsSpan = dojo.byId("warnings");
			document.getElementById("warningMsgs").style.display = "";

			if (newPassword.value == '')
			{
				var msg = '<change:resource key="XfieldCannotBeEmpty"><change:param><change:resource key="newPassword"/></change:param></change:resource>';
				dojo.byId("warningIcon").style.display = "";
				warningsSpan.innerHTML = msg;
				newPassword.focus();
			}
			else if (confirmPassword.value == '')
			{
				var msg = '<change:resource key="XfieldCannotBeEmpty"><change:param><change:resource key="confirmPassword"/></change:param></change:resource>';
				dojo.byId("warningIcon").style.display = "";
				warningsSpan.innerHTML = msg;
				confirmPassword.focus();
			}
			else if (newPassword.value != confirmPassword.value)
			{
				warningsSpan.innerHTML = "<change:resource key='err00549'/>";
				dojo.byId("warningIcon").style.display = "";
				newPassword.value = "";
				confirmPassword.value = "";
				newPassword.focus();
			}
			else
			{
				var errorMsg = validatePassword(newPassword.value, passwordPolicy, false);
				if (errorMsg == "")
				{
					//Ajax call to change the user password.
					LdapUserUtilsAjax.changeUserPassword(document.loginForm.userName.value,
						encodePassword(newPassword.value), encodePassword(tempPassword), 
						DwrCall.getMetadata(updatePasswordCallBack, updatePasswordFailureCallBack, false, false,
							function(){ dlg.hide() }));
				}
				else
				{
					warningsSpan.innerHTML = errorMsg;
					dojo.byId("warningIcon").style.display = "";
					newPassword.value = "";
					confirmPassword.value = "";
					newPassword.focus();
				}
			}
		}

		/**
		* AJAX error callback function while updating a user's password.
		*/
		function updatePasswordFailureCallBack(errorMessage)
		{
			dlg.hide();
			window.location.href = unescape("${applicationScope.contextRoot}" + "/user");
		}

		/**
		 * Required function for XMLHttpRequest.js
		 *
		 */
		function updatePasswordCallBack(result)
		{
			eval(result);
		}

		function loginResult(errorMessage)
		{
			if (errorMessage != "")
			{
				dojo.byId("warnings").innerHTML = errorMessage;
				dojo.byId("warningIcon").style.display = "";
				dojo.byId("newPassword").value = "";
				dojo.byId("confirmPassword").value = "";
				dojo.byId("newPassword").focus();
			}
			else
			{
				tempPassword = dojo.byId("newPassword").value;
				dlg.hide();
				//after successful change of password, authenticate and authorize the user and log him in.
				checkForCookieBeforeLogin();				
			}
		}

		function resetPolicyDialog()
		{
			dojo.byId("newPassword").value = "";
			dojo.byId("confirmPassword").value = "";
			dojo.byId("warnings").innerHTML = "";
			dojo.byId("warningIcon").style.display = "none";
		}
		function showPolicyDialog()
		{
			resetPolicyDialog();
			dlg.show();
			setTimeout('dojo.byId("newPassword").focus()',250);
		}
		function pswdExpiryMsgDialogClose()
		{
			confirmdlg.hide();
			checkForCookieBeforeLogin();
		}

		function pswdExpiryMsgDialogOk()
		{
			confirmdlg.hide();
			showPolicyDialog();
		}

		function ok_onKeypress(evt)
		{
			if (evt.keyCode == 13)
			{
				okPopupClose();
			}
		}		

		dojo.addOnLoad(loadLogin);
	</script>
	</head>

	<body class="bodyStyle">
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=custom_controls/password_model_dialog.CUSTOM -->
				<!-- PARAM NAME=SUB_SHOW_FORM VALUE=submit -->
			<!-- /WSLET -->
		</change:wsletExpander>

		<html:form action="admin" method="post">
			<table width="560px" border="0" cellspacing="0" cellpadding="0" class="login">
				<tr class="loginBlockStyleLarge">
					<td>
						<div class="loginBlockStyleNormal">

							<span style="font-weight: bold;"><change:resource key="userLoginLabel"/></span>

							<c:set var="buildNumber">
								<change:wsletExpander>
									<!-- WSLET CODE=PTAdmin -->
										<!-- PARAM name=BUILD_NUMBER -->
									<!-- /WSLET -->
								</change:wsletExpander>
							</c:set>
							<change:resource key="release" bundle="52_patch">
								<change:param value="${buildNumber}"/>
							</change:resource>
						</div>
					</td> 
				</tr>

				<tr height="130px">
					<td>
						<table width="560px" border="0" class="padd">
							<tbody id="loginBlock">
								<tr>
									<td width="30%" align="right" valign="middle" class="bold">
										<label for="userName">
											<change:resource key="lbl00003"/>
										</label>
									</td>
									<td  colspan="2" width="40%" align="left" valign="middle">
										<html:text style="width: 16em" property="userName" styleId="userName"/>
									</td>
								</tr>
								<tr>
									<td width="30%" align="right" valign="middle" class="bold">
										<label for="password">
											<change:resource key="lbl00004"/>
										</label>	
									</td>
									<td width="40%" align="left" valign="middle">
										<input style="width: 16em" type="password" name="password" id="password">
									</td>
									<td width="30%" align="left" valign="middle">
										<button property="page" id="loginButton" styleClass="button" onclick="authenticate(event)"><change:resource key="lbl00125"/></button>
									</td>
								</tr>
							</tbody>
							<tr id="cookieBlock" style="display: none;">
								<td width="30%"></td>
								<td align="left" colspan="2" valign="middle">
									<html:checkbox property="isCookiePresent" styleId="isCookiePresent"></html:checkbox>
									<label for="isCookiePresent"><span id="cookieValue"></span></label> 
								</td>
							</tr>
							
							<tr id="authenticating" style="display: none;">
								<td colspan="3" align="center" valign="middle">
									<img src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">&nbsp;&nbsp;<change:resource key="authenticating"/>
								</td>
							</tr>
							<tr id="connecting" style="display: none;">
								<td colspan="3" align="center" valign="middle">
									<img src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">&nbsp;&nbsp;<change:resource key="connecting"/>
								</td>
							</tr>
							<tr id="dbAndRolesList" style="display: none;">
								<td colspan="3">
									<table width="560px" class="padd">
										<tr>
											<td width="30%" align="right" valign="middle" class="bold">
												<label for="dbList">
													<change:resource key="lbl00100"/>
												</label>	
											</td>
											<td colspan="2" align="left" valign="middle" id="dbOptions">
												<html:hidden property="database"/>
											</td>
										</tr>
										<tr>
											<td width="30%" align=right valign="middle" class="bold">
												<label for="roleList">
													<change:resource key="lbl00124"/>
												</label>	
											</td>
											<td width="40%" align="left" valign="middle" id="roleOptions">
												<html:hidden property="role"/>
											</td>
											<td width="30%" align="left" valign="middle">
												<html:button property="connectButton" onclick="login();">
													<change:resource key="connectButtonLbl"/>
												</html:button>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<tr id="launchInNewWindow" style="display: none;">
								<td width="30%"></td>
								<td align="left" colspan="2" valign="middle" class="launchInNewWindow">
									<html:checkbox property="isLaunchInCurrentWindowSet" styleId="isLaunchInCurrentWindowSet"></html:checkbox>
									<label for="isLaunchInCurrentWindowSet">
										<change:resource key="lbl00126"/>
									</label>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
			
			<html:hidden property="databaseAlias"/>
			<html:hidden property="token"/>
			<INPUT NAME="TEMPLATE_FLAG"  TYPE="HIDDEN" VALUE="NO_ACTION">
			<INPUT NAME="ACTION_FLAG"  TYPE="HIDDEN" VALUE="NO_ACTION">
		</html:form>
		
		<%-- Includes the message of the day if defined by the admin and set to on --%>
		<c:set var="motdPage">
			<change:wsletExpander>
			<!-- WSLET CODE=PTLoadData -->
			<!-- PARAM NAME=MESSAGE_OF_THE_DAY VALUE=JSP -->
			<!-- /WSLET -->
			</change:wsletExpander>
		</c:set>
		
		<c:set var="footerPadding" value="padding-top: 10px;"/>
		<c:if test="${motdPage != ''}">
			<jsp:include page="/WEB-INF/wsconfig/templates/pt/forms/motd.jsp">
				<jsp:param name="isLoginPage" value="true"/>
			</jsp:include>
			<c:set var="footerPadding" value=""/>
		</c:if>
		
		<div class="footer" style="${footerPadding}">
			<a href="javascript: openBrowserSupport()"><change:resource key="info0109"/></a>
			|
			<a href="javascript: openCookiePolicy();"><change:resource key="cookiePolicyAction"/></a>
		</div>
		
		<form name="framesetForm" method="post" action="<change:urlCreator webResource='BASEURL'/>/framesetLoader.do">
			<input name="token" type="hidden">
			<input name="frameName" type="hidden" value="panelAndDialog">
			<input name="isLaunchInCurrentWindowSet" type="hidden">
			<input name="userName" type="hidden">
			<input name="database" type="hidden">
			<input name="role" type="hidden">
			<input name="methodToCall" type="hidden" value="createLoginCookie">
		</form>
</body>
</html:html>


