<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\user_relogin.jsp -->
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>

<!-- user_relogin.jsp page displays Login page for user re-login -->

<html:html locale="true">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=<change:charEncoding/>">
		<title><change:resource key="userLoginTitle"/></title>
		<style type="text/css">
			@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css";
		
			<change:wsletExpander>
				 <!-- WSLET CODE=PTInclude -->
				 <!-- PARAM NAME=styles/login.css -->
				 <!-- PARAM NAME=styles/note.css -->
				 <!-- PARAM NAME=styles/passwordPolicy.css -->
				 <!-- /WSLET -->
			</change:wsletExpander>
		</style> 

	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>loginScripts.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LoginUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/LdapUserUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	<script type="text/javascript">
		dojo.require('dijit.Dialog');
	</script>

	<script type="text/javascript">
		<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM NAME=MessageFormat.js -->
		<!-- PARAM NAME=browserDetect.js -->
		<!-- PARAM NAME=StringBuffer.js -->		
		 <!-- /WSLET -->
		</change:wsletExpander>

		<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM NAME=validation.js -->		
		<!-- PARAM NAME=passwordPolicy.js -->
		 <!-- PARAM NAME=EventUtils.js -->
		<!-- /WSLET -->		
		</change:wsletExpander>
				
		var dlg;
		var confirmdlg;
		var infodlg;
		var passwordPolicy;
		var tempPassword;
		
		/**
		 * On load function. Shows the login page.
		 */		
		function loadLogin()
		{					
			showLogin();

			EventUtils.addEvent(document.loginForm.userName, 'keypress', loginFields_onKeyup);
			EventUtils.addEvent(document.loginForm.password, 'keypress', loginFields_onKeyup);
			EventUtils.addEvent(document.getElementById('newPassword'), 'keypress', ok_onKeypress);
			EventUtils.addEvent(document.getElementById('confirmPassword'), 'keypress', ok_onKeypress);	
		}

		/**
		 * Authenticates the user.
		 */
		function authenticate(e)
		{
			EventUtils.preventDefault(e);
			if (!validateForm())
			{
				return false;
			}

			//display Authenticate message with 'spin' icon
			authenticating();

			//AJAX call to authenticate the user, This check is necessary to see authentication related errors if any
			LoginUtilsAjax.preLogin(document.loginForm.userName.value, encodePassword(document.loginForm.password.value), preLoginAuthCallback);
		}
		
		/**
		 * AJAX callback function for preLogin.
		 */
		function preLoginAuthCallback(loginResult)
		{
			tempPassword = document.loginForm.password.value;

			if (!(loginResult.authSuccess))
			{				
				if (!loginResult.preLoginCheckSuccess)
				{
					alert(loginResult.errorMessage);
					//refresh the page				
					window.self.location = "${loginForm.map.context}";
				}
				else
				{
					showLogin();
					alert(loginResult.errorMessage);
				}
					
				return false;
			}
			else if (loginResult.passwordExpired || loginResult.daysToExpire > 0 || loginResult.passwordReset)
			{				
				showPasswordExpiryMessage(loginResult);
				return;
			}			
			else
			{
				if (hasDatabaseAccess(loginResult))
				{
					login();
				}
				else
				{
					showLogin();
					alert('<change:resource key="noLoginAccess"/>');
				}					
			}
		}

		/**
		 * Validate the login form for user name and password.
		 */
		function validateForm()
		{
			if ((!hasNonWhiteSpaceChar(document.loginForm.userName.value)))		
			{
				alert('<change:resource key="userNameRequired"/>');
				document.loginForm.userName.focus();
				return false;
			}
			if ((!hasNonWhiteSpaceChar(document.loginForm.password.value)))		
			{
				alert('<change:resource key="passwordRequired"/>');
				document.loginForm.password.focus();
				return false;
			}	
			return true;		
		}		
		
		/**
		 * AJAX call for user login.
		 */
		function login()
		{
			showConnectingMsg();
			LoginUtilsAjax.reLogin(document.loginForm.userName.value, encodePassword(tempPassword), document.loginForm.role.value, document.loginForm.database.value, loginAuthCallback);
		}
		
		/**
		 * AJAX callback function for user login.
		 */
		function loginAuthCallback(loginResult)
		{
			document.loginForm.token.value = loginResult.token;
			if (loginResult.token == null)
			{
				showLogin();
				alert(loginResult.errorMessage);

				if (!loginResult.preLoginCheckSuccess)
				{
					//refresh the page				
					window.self.location = "${loginForm.map.context}";
				}
			}
			else
			{
				formSubmit();
			}
		}

				
		/**
		 * Submit the form to show the user requested information, after successful login.
		 */
		function formSubmit()
		{
			var token = document.loginForm.token.value;
			if (token != null)
			{
				window.self.location = "${loginForm.map.context}";
			}
			else
			{
				showLogin();
				alert('<change:resource key="noLoginAccess"/>');
			}
		}
	
		/**
		 * Show the user re-login page.
		 */
		function showLogin()
		{
			document.loginForm.password.value = "";
			document.getElementById("credentialsTable").style.display = "";
			document.getElementById("authenticating").style.display = "none";
			document.getElementById("connecting").style.display = "none";
			if (document.getElementById('login-help-link').style.display == "none")
			{
				document.getElementById('login-help').style.display = "";
			}
			else
			{
				document.getElementById('login-help').style.display = "none";
			}
			document.loginForm.userName.focus();
			document.loginForm.userName.select();
		}

		/**
		 * Show 'spin' icon with message 'Authenticating'
		 */
		function authenticating()
		{
			document.getElementById("credentialsTable").style.display = "none";
			document.getElementById("authenticating").style.display = "";		
		}
		
		/**
		 * Show 'spin' icon with message 'Connecting'
		 */
		function showConnectingMsg()
		{
			document.getElementById("authenticating").style.display = "none";					
			document.getElementById("connecting").style.display = "";
			
			// After successfully changing the password through the password reset dialog, 
			// hide the following elements also.
			document.getElementById("credentialsTable").style.display = "none";
		}

		function loginHelp_onClick(e)
		{
			EventUtils.preventDefault(e);	
			document.getElementById('login-help').style.display = "";
			document.getElementById('login-help-link').style.display = 'none';
		}		

		function loginFields_onKeyup(evt)
		{
			if (evt.keyCode == 13)
			{
				authenticate(evt);
			}
		}
			
		/** 
		 * Shows the password expiry or reset messages.		
		 */
 		 var pwdAboutToExpire = false;
		function showPasswordExpiryMessage(loginResult)
		{
			pwdAboutToExpire = false;
			var message = loginResult.errorMessage;
			var canChangePassword = loginResult.canUserChangePassword;
			var isPasswordExpired = loginResult.passwordExpired;
			var isPasswordReset = loginResult.passwordReset;
			passwordPolicy = loginResult.passwordPolicy;
			
			showLogin();
			writePasswordPolicy(document.getElementById("policyContent"), passwordPolicy);
			dlg = dijit.byId("popupDialog");

			if (!passwordPolicy.checkPasswordSyntax)
			{
				document.getElementById("policy").style.display = "none";
			}
			else
			{
				document.getElementById("policy").style.display = "";
			}

			confirmdlg = dijit.byId("pswdExpiryMsgDialog");
		
			infodlg = dijit.byId("infoDialog");
			
			if (isPasswordReset)	//password is reset
			{
				if (canChangePassword)
				{
					document.getElementById("policyLabel").style.display = "";
					dojo.byId("pswdLblId").innerHTML = "<change:resource key='passwordResetLbl'/>";
					showPolicyDialog();
					return;
				}
				else
				{
					login();	
				}
			}
			else if (isPasswordExpired)	//password has expired
			{
				//load the password updation page only if the user has rights to change password.
				if (canChangePassword)
				{
					document.getElementById("policyLabel").style.display = "";
					dojo.byId("pswdLblId").innerHTML = "<change:resource key='passwordExpireLbl'/>";
					showPolicyDialog();
					return;
				}
				else
				{
					var infoMsgSpan = dojo.byId("infoMsg");					
					infoMsgSpan.innerHTML = message;
					dojo.byId("pswdExpired").value = true;
					infodlg.show();
					dojo.byId("infoHider").focus();			
				}
			}
			else	//password has not expired yet
			{
				pwdAboutToExpire = true;
				if (canChangePassword)
				{
					//load the password updation page only if the user has rights to change password.
					dojo.byId("pswdExpiryMsg").innerHTML = message;
					confirmdlg.show();
					document.getElementById("pswdExpiryMsgDialogOk").focus();
					return;				
				}
				else	//If user has no rights to change password, show the message and process the login.
				{
					dojo.byId("infoMsg").innerHTML = message;
					dojo.byId("pswdExpired").value = false;
					infodlg.show();
					document.getElementById("infoHider").focus();
					return;
				}				
			}				
		}

		function closeInfoDialog()
		{
			infodlg.hide();
			var pswdExpired = dojo.byId("pswdExpired").value;
			
			if (pswdExpired=='true')
			{
				showLogin();
			}
			else
			{
				login();	
			}			
		}
		
		function cancelPopupClose()
		{
			dlg.hide();			
			if (pwdAboutToExpire)
			{
				login();
			}
			else
			{
				showLogin();
			}
		}
		
		//The modal dialog has been dimissed by clicking the ok button, capture the changes.
		function okPopupClose()
		{
			var newPassword = dojo.byId("newPassword");
			var confirmPassword = dojo.byId("confirmPassword");
			var warningsSpan = dojo.byId("warnings");
			document.getElementById("warningMsgs").style.display = "";
			
			if (newPassword.value == '')
			{
				var msg = '<change:resource key="XfieldCannotBeEmpty"><change:param><change:resource key="newPassword"/></change:param></change:resource>';
				dojo.byId("warningIcon").style.display = "";
				warningsSpan.innerHTML = msg;
				newPassword.focus();
			}
			else if (confirmPassword.value == '')
			{
				var msg = '<change:resource key="XfieldCannotBeEmpty"><change:param><change:resource key="confirmPassword"/></change:param></change:resource>';
				dojo.byId("warningIcon").style.display = "";
				warningsSpan.innerHTML = msg;
				confirmPassword.focus();
			}			
			else if (newPassword.value != confirmPassword.value) 
			{
				warningsSpan.innerHTML = "<change:resource key='err00549'/>";
				dojo.byId("warningIcon").style.display = "";
				newPassword.value = "";
				confirmPassword.value = "";
				newPassword.focus();
			}
			else
			{
				var errorMsg = validatePassword(newPassword.value,passwordPolicy, false);
				if (errorMsg == "")
				{
					//Ajax call to change the user password.
					LdapUserUtilsAjax.changeUserPassword(document.loginForm.userName.value, 
						encodePassword(newPassword.value), encodePassword(tempPassword),{callback:updatePasswordCallBack, errorHandler:updatePasswordFailureCallBack});
				}
				else
				{
					warningsSpan.innerHTML = errorMsg;
					dojo.byId("warningIcon").style.display = "";
					newPassword.value = "";
					confirmPassword.value = "";
					newPassword.focus();
				}
			}
		}

		/**
		* AJAX error callback function while updating a user's password.
		*/
		function updatePasswordFailureCallBack(errorMessage)
		{
			dlg.hide();
			window.self.location = "${loginForm.map.context}";
		}

		/**
		 * Required function for XMLHttpRequest.js
		 *
		 */
		function updatePasswordCallBack(result)
		{
			eval(result);
		}

		function loginResult(errorMessage)
		{
			if (errorMessage != "")
			{
				dojo.byId("warnings").innerHTML = errorMessage;
				dojo.byId("warningIcon").style.display = "";
				dojo.byId("newPassword").value = "";
				dojo.byId("confirmPassword").value = "";
				dojo.byId("newPassword").focus();			
			}
			else
			{
				tempPassword = dojo.byId("newPassword").value;
				dlg.hide();
				//after successful change of password, authenticate and authorize the user and log him in.
				login();	
			}
		}
		
		function resetPolicyDialog()
		{
			dojo.byId("newPassword").value = "";
			dojo.byId("confirmPassword").value = "";
			dojo.byId("warnings").innerHTML = "";
			dojo.byId("warningIcon").style.display = "none";
		}
		function showPolicyDialog()
		{
			resetPolicyDialog();
			dlg.show();
			dojo.byId("newPassword").focus();
		}
		
		function pswdExpiryMsgDialogClose()
		{
			confirmdlg.hide();
			login();
		}
		
		function pswdExpiryMsgDialogOk()
		{
			confirmdlg.hide();
			showPolicyDialog();
		}
		
		function ok_onKeypress(evt)
		{
			if (evt.keyCode == 13)
			{
				okPopupClose();
			}
		}
		
		
		/**
		 * This function checks whether user has access to the database which is set in context or not.
		 */
		function hasDatabaseAccess(loginResult)
		{
			var dbAndRolesList = loginResult.databaseAndRole;
			var hasAccess = false;
			databaseInContext = document.loginForm.database.value;
			
			if (!(dbAndRolesList.length ==0))
			{
				for (i=0; i < dbAndRolesList.length; i++)
				{
					if (dbAndRolesList[i].databaseName == databaseInContext)
					{
						var roles = dbAndRolesList[i].webRolesList;
						
						if (roles.length != 0)
						{
							var roleInContext = document.loginForm.role.value;
							
							for (var j=0; j < roles.length; j++)
							{
								if (roles[j] == roleInContext)
								{
									hasAccess = true;
									break;
								}
							}
						}
					}
				}
			}	
		
			return hasAccess;
		}		
		
		dojo.addOnLoad(loadLogin);
	</script>	
	</head>

	<body class="bodyStyle">
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=custom_controls/password_model_dialog.CUSTOM -->
			<!-- PARAM NAME=SUB_SHOW_FORM VALUE=submit -->
			<!-- /WSLET -->
		</change:wsletExpander>

		<html:form action="reLogin.do" method="post">
			<table width="560px" border="0" cellspacing="0" cellpadding="0" class="login">
				<tr class="loginBlockStyleLarge">
					<td>
						<div class="loginBlockStyleNormal">

							<span style="font-weight: bold;"><change:resource key="userLoginLabel"/></span>

							<c:set var="buildNumber">
								<change:wsletExpander>
									<!-- WSLET CODE=PTAdmin -->
										<!-- PARAM name=BUILD_NUMBER -->
									<!-- /WSLET -->
								</change:wsletExpander>
							</c:set>
							<change:resource key="release" bundle="52_patch">
								<change:param value="${buildNumber}"/>
							</change:resource>
						</div>
					</td> 
				</tr>

				<tr id="credentialsTable" height="70px">
					<td>
						<table width="100%" class="padd" style="padding-bottom: 10px;">
							<tr>
								<td width="30%" align=right valign="middle" class="bold">
									<label for="userName">
										<change:resource key="lbl00003"/>
									</label>
								</td>
								<td colspan="2" width="70%" align="left" valign="middle">
									<html:text style="width: 16em" property="userName" styleId="userName" styleClass="text"/>
								</td>								
							</tr>
							<tr>
								<td width="30%" align=right valign="middle" class="bold">
									<label for="password">
										<change:resource key="lbl00004"/>
									</label>
								</td>
								<td width="40%" align="left" valign="middle">
									<html:password style="width: 16em" property="password" styleId="password" styleClass="text"/>
								</td>
								<td width="30%" align="left" valign="middle">
									<html:button property="page" styleClass="button" onclick="authenticate(event)"><change:resource key="lbl00125"/></html:button>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr id="authenticating" height="70px" style="display: none; padding-bottom: 10px;">
					<td align="center" valign="middle">
						<img src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">&nbsp;&nbsp;<change:resource key="authenticating"/>
					</td>
				</tr>
				<tr id="connecting" height="70px" style="display: none; padding-bottom: 10px;">
					<td align="center" valign="middle">
						<img src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">&nbsp;&nbsp;<change:resource key="connecting"/>
					</td>
				</tr>
			</table>
			
			<center>
				<table width="560px" border=0 cellspacing=0 cellpadding=0>					
					<tr>
						<td align="center">
							<div id="login-help-link" >
								<a href="#" onclick="loginHelp_onClick(event)">
									<change:wsletExpander>
										<!-- WSLET CODE=PTString -->
										<!-- PARAM NAME=RESOURCE_STRING VALUE=reloginHelpLink -->
										<!-- /WSLET -->
									</change:wsletExpander>
								</a>
							</div>
						</td>
					</tr>
				</table>
				<div id="login-help" class="note" style="display: none;width: 560px">
					<P>
						<change:wsletExpander>
							<!-- WSLET CODE=PTString -->
							<!-- PARAM NAME=RESOURCE_STRING VALUE=reloginHelpText -->
							<!-- /WSLET -->
						</change:wsletExpander>
					</P>
					<UL>
						<change:wsletExpander>
							<!-- WSLET CODE=PTString -->
							<!-- PARAM NAME=RESOURCE_STRING VALUE=reloginReasonsList -->
							<!-- /WSLET -->
						</change:wsletExpander>
					</UL>
				</div>
			</center>
			<html:hidden property="database"/>
			<html:hidden property="token"/>
			<html:hidden property="role"/>
		</html:form>
</body>
</html:html>																				
