
<!-- ----------------------------------------------------------------- -->
/* 
 * calendar.js
 *
 * Loads the calendar component into a new window 
 *
 * PARAMETERS
 * ctrlDate:	The input name on the form to associate the calendar
 *				object with.
 *
 */

<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SUBMIT_DATE_FORMAT --><!-- /WSLET -->
<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=QUERY_DATE_FORMAT --><!-- /WSLET -->



function Calendar(ctrlDate)
{
	Calendar_constructor(ctrlDate, "", "0:0:0");
}

Calendar.SPACE = '%20';
Calendar.TIME_SPLITTER = ':';
Calendar.AM = '<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='am' --><!-- /WSLET -->';
Calendar.PM = '<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='pm' --><!-- /WSLET -->';

Calendar.dateErrorOccurred = false;

function Calendar_42sp1(ctrlDate,formType)
{
	Calendar_constructor(ctrlDate, formType, "0:0:0");
}

function Calendar_42sp1_default_time(ctrlDate,formType,defaultTime)
{
	Calendar_constructor(ctrlDate, formType, defaultTime);
}

function Calendar_43(ctrlDate,formType)
{
	Calendar_constructor(ctrlDate, formType, "");
}

function Calendar_constructor(ctrlDate, formType, defaultTime)
{
	window.dateField   = ctrlDate;
	window.formType    = formType;
	window.defaultTime = defaultTime;
	
	var url = "<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SERVLET_PATH VALUE=PTWEB_SERVLET --><!-- /WSLET -->" +
		      "?ACTION_FLAG=admin_form" +
			  "&TEMPLATE_FLAG=Calendar" +
			  "&role=" + escape(role) +
	          "&token=" + token;
	
	newWin = window.open(url, "cal", "width=200,height=260", false);
	newWin.focus();
}

function QueryReplace_DateString(qry_string, toFind, mode)
{
	var strFrom  = new String(qry_string);						
	var strRet   = new String("");
	var iLength  = strFrom.length;
	var iStart   = 0;
	var iEnd     = 0;
		
	if(strFrom.indexOf(toFind) < 0)
		return(strFrom);

	if(iLength > 0)
	{
		while(iStart >= 0)
		{
			iStart = strFrom.indexOf(toFind, iEnd);
					
			if(iStart > 0)
			{
				strRet += strFrom.substring(iEnd, iStart);
				switch(mode)
				{
					case 0:
							strRet += "time('" + GetToday('QUERY') + "')";
							break;
					case 1:
							strRet += "time('" + GetToday('QUERY') + " 0:0:0')";
							break;
					case 2:
							strRet += "time('" + GetToday('QUERY') + " 23:59:59')";
							break;
				}

				iEnd = iStart + toFind.length;
			}
		}
			
		strRet += strFrom.substring(iEnd, iLength);
	}
	
	return(strRet);
}

function QueryReplace(qry_string)
{
	var strFrom  = new String(qry_string);						
	var toFind   = new String("%username");
	var strRet   = new String("");
	var iLength  = strFrom.length;
	var iStart   = 0;
	var iEnd     = 0;
		
	if(strFrom.indexOf(toFind) < 0)
		return(strFrom);

	if(iLength > 0)
	{
		while(iStart >= 0)
		{
			iStart = strFrom.indexOf(toFind, iEnd);
					
			if(iStart > 0)
			{
				strRet += strFrom.substring(iEnd, iStart);
				strRet += user;
				iEnd = iStart + toFind.length;
			}
		}
			
		strRet += strFrom.substring(iEnd, iLength);
	}
	
	return(strRet);
}

/*
	Given a date format (ex, MM/dd/yyyy H:mm:ss or dd.MM.yyyy H:mm:ss) format the seperate
	date components	into the correctly formatted string by replacing each string value with
	its numerical value.  (ex, MM is replaced by month and yyyy is replaced by year)
*/
function formatDate(dateFormat, year, month, day, hours, minutes, seconds, amPm)
{
	var localDateFormat = dateFormat;
	
	var doubleMonth = month;;
	var doubleDay = day;;
	var doubleHours = hours;
	var doubleMinutes = minutes;
	var doubleSeconds = seconds;
	
	if (month <= 9)
		doubleMonth = "0" + month;
	if (day <= 9) 
		doubleDay = "0" + day;
	if (hours <= 9) 
		doubleHours = "0" + hours;
	if (minutes <= 9) 
		doubleMinutes = "0" + minutes;
	if (seconds <= 9) 
		doubleSeconds = "0" + seconds;
	
	localDateFormat = localDateFormat.replace(/yyyy/, year);
	localDateFormat = localDateFormat.replace(/MM/, doubleMonth);
	localDateFormat = localDateFormat.replace(/dd/, doubleDay);
	localDateFormat = localDateFormat.replace(/HH/, doubleHours);
	localDateFormat = localDateFormat.replace(/H/, hours);
	localDateFormat = localDateFormat.replace(/hh/, doubleHours);
	localDateFormat = localDateFormat.replace(/h/, hours);
	localDateFormat = localDateFormat.replace(/mm/, doubleMinutes);
	localDateFormat = localDateFormat.replace(/m/, minutes);
	localDateFormat = localDateFormat.replace(/ss/, doubleSeconds);
	localDateFormat = localDateFormat.replace(/s/, seconds);
	localDateFormat = localDateFormat.replace(/a/, amPm);
	localDateFormat = localDateFormat.replace(/Z/, getTimeZone());
	localDateFormat = localDateFormat.replace(/'T'/, "T");

	return localDateFormat;
}

function GetToday(formtype)
{
	today = new Date();

	var year  = today.getFullYear();
	var month = today.getMonth()+1;
	var day   = today.getDate();
	var hours = 0;
	var minutes = 0;
	var seconds = 0;

	if(formtype == 'SUBMIT')
	{
		return formatDate(SubmitDateFormat, year, month, day, hours, minutes, seconds, '');
	}

	// Default: MM/dd/yyyy	
	return formatDate("MM/dd/yyyy", year, month, day, hours, minutes, seconds, '');
}

function isDateOrDatePattern(strDate)
{
	var str      = new String(strDate);
	var keywords = new Object();

	keywords["%now"]             =1;
	keywords["%today_begin"]     =1;
	keywords["%today_end"]       =1;
	keywords["%this_week_begin"] =1;
	keywords["%this_week_end"]   =1;
	keywords["%this_month_begin"]=1;
	keywords["%this_month_end"]  =1;
	keywords["%this_year_begin"] =1;
	keywords["%this_year_end"]   =1;
	
	return((str.search(/^%today_(plus|minus)\d+(days|weeks|months|years)$/) != -1) || (keywords[strDate] == 1));
}

function peform2DigitYearPromotion(dateStr)
{
	// Year must last... [MM/dd/yyyy|dd/MM/yyyy|dd.MM.yyyy]
	var split = dateStr.split(unescape('%20'));
	var match = split[0].match(/[0-9]+$/);
	// convert 2-digit year to a 4-digit year
	if ((match != null) && (match[0].length == 2))
	{
		var year = parseInt(match[0],10);
		year += (year < 70 ? 2000 : 1900);
		if (split.length == 1)
			return(dateStr.substring(0, match.index) + year);
		else
			return(dateStr.substring(0, match.index) + year + unescape('%20') + split[1]);
	}
	if ((match != null) && (match[0].length == 3))
	{
		alert('<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00092' --><!-- /WSLET -->');
		return null;
	}
	if ((match != null) &&(match[0].length > 4))
	{
		alert('<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00093' --><!-- /WSLET -->');
		return null;
	}
	return(dateStr);
}

function Valid_Date(strDate)
{
	// Default Format: MM/dd/yyyy
	Calendar.dateErrorOccurred = false;

	if((strDate == "") || isDateOrDatePattern(strDate))
	{
		return errorDateReturn(strDate, isValidate);
	}
	
	var theDate = new Date(peform2DigitYearPromotion(strDate));
	if(isNaN(theDate))
	{
		Calendar.dateErrorOccurred = true;
		alert('<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00094' --><!-- /WSLET -->');
		return errorDateReturn(strDate, isValidate);
	}
	
	return((theDate.getMonth() + 1) + '/' + theDate.getDate() + '/' + theDate.getFullYear());
}

function QueryValue(strDate, attrName)
{
	if(QueryDateFormat == 'MM/dd/yyyy H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00095' --><!-- /WSLET -->";
		var time1 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 24);
		var time2 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 24);

		return('(' + attrName + '>=time(\'' + time1 + '\')) and (' + attrName + '<=time(\'' + time2.replace(/0:00:00/, '23:59:59') + '\'))');
	}
	if(QueryDateFormat == 'dd/MM/yyyy H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00097' --><!-- /WSLET -->";
		var time1 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
		var time2 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	
		return('(' + attrName + '>=time(\'' + time1 + '\')) and (' + attrName + '<=time(\'' + time2.replace(/0:00:00/, '23:59:59') + '\'))');
	}
	if(QueryDateFormat == 'dd.MM.yyyy H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00099' --><!-- /WSLET -->";
		var time1 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, ".", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
		var time2 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, ".", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	
		return('(' + attrName + '>=time(\'' + time1 + '\')) and (' + attrName + '<=time(\'' + time2.replace(/0:00:00/, '23:59:59') + '\'))');
	}
	if(QueryDateFormat == 'yyyy/MM/dd H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00101' --><!-- /WSLET -->";
		var time1 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
		var time2 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
		
		return('(' + attrName + '>=time(\'' + time1 + '\')) and (' + attrName + '<=time(\'' + time2.replace(/0:00:00/, '23:59:59') + '\'))');
	}
	if (QueryDateFormat == 'yyyy/MM/dd h:mm:ss a')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00102' --><!-- /WSLET -->";
		var time1 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 12);
		var time2 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 12);
		
		return('(' + attrName + '>=time(\'' + time1 + Calendar.AM + '\')) and (' + attrName + '<=time(\'' + time2.replace(/0:00:00/, '11:59:59') + Calendar.PM + '\'))');
	}
	if (QueryDateFormat == 'MM/dd/yyyy h:mm:ss a')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00104' --><!-- /WSLET -->";
		var time1 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 12);
		var time2 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 12);
		
		return('(' + attrName + '>=time(\'' + time1 + Calendar.AM + '\')) and (' + attrName + '<=time(\'' + time2.replace(/0:00:00/, '11:59:59') + Calendar.PM + '\'))');
	}
	if(QueryDateFormat == 'yyyy-MM-dd HH:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00090' --><!-- /WSLET -->";
		var time1 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "-", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
		var time2 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "-", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
		
		return('(' + attrName + '>=time(\'' + time1 + '\')) and (' + attrName + '<=time(\'' + time2.replace(/00:00:00/, '23:59:59') +'\'))');
	}
	if(QueryDateFormat == "yyyy-MM-dd'T'HH:mm:ssZ")
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00088' --><!-- /WSLET -->";
		var time1 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "-", "T", Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
		var time2 = getDateWithFormat(strDate, QueryDateFormat, true, eString, false, "-", "T", Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
		
		return('(' + attrName + '>=time(\'' + time1 + '\')) and (' + attrName + '<=time(\'' + time2.replace(/00:00:00/, '23:59:59') + '\'))');
	}

	return(strDate);
}

function String2Date(strDate, strFormat)
{
	// No time of day
	if(strFormat == 'MM/dd/yyyy')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00094' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 24);
	}
	if(strFormat == 'dd/MM/yyyy')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00096' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	}
	if(strFormat == 'dd.MM.yyyy')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00098' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, false, ".", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	}
	if(strFormat == 'yyyy/MM/dd')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00100' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, false, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
	}

	// With time of day
	if(strFormat == 'MM/dd/yyyy H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00095' --><!-- /WSLET -->"; 
		return getDateWithFormat(strDate, strFormat, false, eString, true, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 24);
	}
	if(strFormat == 'dd/MM/yyyy H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00097' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, true, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	}
	if(strFormat == 'dd.MM.yyyy H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00099' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, true, ".", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	}
	if(strFormat == 'yyyy/MM/dd H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00101' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, true, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
	}
	if(strFormat == 'yyyy/MM/dd h:mm:ss a')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00102' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, true, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 12);
	}
	if(strFormat == 'MM/dd/yyyy h:mm:ss a')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00104' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, true, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 12);
	}
	if(strFormat == 'yyyy-MM-dd HH:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00090' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, true, "-", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 12);
	}
	if(strFormat == "yyyy-MM-dd'T'HH:mm:ssZ")
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00088' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, strFormat, false, eString, true, "-", "T", Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 12);
	}	

	// Format was not accounted for
	PTAlert("<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00606' --><!-- /WSLET --> " + strFormat,1);
	return(new Date(strDate));
}

function Valid_Date_No_Time(strDate,formType)
{
	Calendar.dateErrorOccurred = false;

	var dateFormat;
	
	if (formType == 'QUERY')
	{
		dateFormat = QueryDateFormat;
		return locale_Valid_Date(strDate, dateFormat, false);
	}
	else if (formType == 'SUBMIT')
	{
		dateFormat = SubmitDateFormat;
		return locale_Valid_Date(strDate, dateFormat, false);
	}

	if((strDate == "") || isDateOrDatePattern(strDate))
	{
		return errorDateReturn(strDate, isValidate);
	}

	var theDate = new Date(peform2DigitYearPromotion(strDate));

	if(isNaN(theDate))
	{
		Calendar.dateErrorOccurred = true;
		alert("<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00069' --><!-- /WSLET -->");
		return errorDateReturn(strDate, isValidate);
	}

	// Default: MM/dd/yyyy
	return formatDate('MM/dd/yyyy', theDate.getFullYear(), theDate.getMonth() + 1, theDate.getDate(), 0,0,0, '');
}

function Valid_Date_With_Time(strDate,formtype)
{
	Calendar.dateErrorOccurred = false;

	var dateFormat;

	if(formtype == 'QUERY')
	{
		dateFormat = QueryDateFormat;
		return locale_Valid_Date(strDate, dateFormat, true);
	}
	else if(formtype == 'SUBMIT')
	{	
		dateFormat = QueryDateFormat;
		return locale_Valid_Date(strDate, dateFormat, true);
	}

	if((strDate == "") || isDateOrDatePattern(strDate))
	{
		return errorDateReturn(strDate, isValidate);
	}

	var theDate = new Date(peform2DigitYearPromotion(strDate));

	if(isNaN(theDate))
	{
		Calendar.dateErrorOccurred = true;
		alert("<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00069' --><!-- /WSLET -->");
		return errorDateReturn(strDate, isValidate);
	}

	// Default: MM/dd/yyyy
	return formatDate('MM/dd/yyyy H:mm:ss', theDate.getFullYear(), theDate.getMonth() + 1, theDate.getDate(),
	                  theDate.getHours(),theDate.getMinutes(),theDate.getSeconds(), '');
}

function locale_Valid_Date(strDate,dateFormat, withTime)
{
	
	if (dateFormat == 'MM/dd/yyyy')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00094' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 24);
	}
	
	if (dateFormat == 'dd/MM/yyyy')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00096' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	}
	
	if (dateFormat == 'dd.MM.yyyy')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00098' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, ".", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	}
	
	if (dateFormat == 'yyyy/MM/dd')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00100' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
	}
	
	if (dateFormat == 'MM/dd/yyyy H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00095' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 24);
	}
	
	if (dateFormat == 'MM/dd/yyyy h:mm:ss a')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00104' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 0, 1, 0, 1, 2, 12);
	}
	
	if (dateFormat == 'dd/MM/yyyy H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00097' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	}
	
	if (dateFormat == 'dd.MM.yyyy H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00099' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, ".", Calendar.SPACE, Calendar.TIME_SPLITTER, 2, 1, 0, 0, 1, 2, 24);
	}
	
	if (dateFormat == 'yyyy/MM/dd H:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00101' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
	}
	
	if (dateFormat == 'yyyy/MM/dd h:mm:ss a')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00102' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "/", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 12);
	}
	
	if (dateFormat == 'yyyy-MM-dd HH:mm:ss')
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00090' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "-", Calendar.SPACE, Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
	}
	
	if (dateFormat == "yyyy-MM-dd'T'HH:mm:ssZ")
	{
		var eString = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='err00088' --><!-- /WSLET -->";
		return getDateWithFormat(strDate, dateFormat, true, eString, withTime, "-", "T", Calendar.TIME_SPLITTER, 0, 1, 2, 0, 1, 2, 24);
	}
}

function errorDateReturn(strDate, isValidate)
{
	if (isValidate)
	{	
		return('');
	}
	else
	{
		return new Date(strDate); 
	}
}

function getDateWithFormat(strDate, dateFormat, isValidate, errorString, includeTime, dateDelimiter, dateTimeSplitter, timeDelimiter, 
                      yearLocation, monthLocation, dayLocation, hourLocation, minuteLocation, secondLocation, maxHours)
{	
	if ((strDate == '') || isDateOrDatePattern(strDate))
	{
		if (isValidate)
		{
			return "";
		}
		else
		{
			return new Date(strDate);
		}
	}
	
	Calendar.dateErrorOccurred = false;
	
	var split1 = strDate.split(unescape(dateTimeSplitter));
	var split2 = split1[0].split(dateDelimiter);
	if (split2.length != 3)
	{
		alert(errorString);
		Calendar.dateErrorOccurred = true;
		return errorDateReturn(strDate, isValidate);
	}
		
	var month = parseInt(split2[monthLocation],10);
	if (isNaN(month))
	{
		alert(errorString);
		Calendar.dateErrorOccurred = true;
		return errorDateReturn(strDate, isValidate);
	}
	
	if ((month < 1) || (month > 12))
	{
		alert(errorString);
		Calendar.dateErrorOccurred = true;
		return errorDateReturn(strDate, isValidate);
	}
	
	var day = parseInt(split2[dayLocation],10);
	if (isNaN(day))
	{
		alert(errorString);
		Calendar.dateErrorOccurred = true;
		return errorDateReturn(strDate, isValidate);
	}
	if ((day < 1)|| (day > 31))
	{
		alert(errorString);
		Calendar.dateErrorOccurred = true;
		return errorDateReturn(strDate, isValidate);
	}
	
	split2[yearLocation] = peform2DigitYearPromotion(split2[yearLocation]);
	if (!split2[yearLocation])
		return errorDateReturn(strDate, isValidate);
	
	var year = parseInt(split2[yearLocation],10);
	if (isNaN(year))
	{
		alert(errorString);
		Calendar.dateErrorOccurred = true;
		return errorDateReturn(strDate, isValidate);
	}

	if (year < 1970)
	{
		alert(errorString);
		Calendar.dateErrorOccurred = true;
		return errorDateReturn(strDate, isValidate);
	}
	
	if (!includeTime)
	{
		if (isValidate)
		{
			return formatDate(dateFormat, year, month, day, 0, 0, 0, '');
		}
		else
		{
			return new Date(year, month, day, 0, 0, 0, 0);
		}
	}
	
	var hours = 0;
	var minutes = 0;
	var seconds = 0;
	var amPM = Calendar.AM;
	
	if ((split1.length == 2) || (split1.length == 3))
	{
		var split3 = split1[1].split(timeDelimiter);
		hours = parseInt(split3[hourLocation],10);
		
		if (isNaN(hours))
		{
			alert(errorString);
			Calendar.dateErrorOccurred = true;
			return errorDateReturn(strDate, isValidate);
		}
		
		if ((hours < 0)||(hours > maxHours))
		{
			alert(errorString);
			Calendar.dateErrorOccurred = true;
			return errorDateReturn(strDate, isValidate);
		}
		
		if (split3.length != 1)
		{	
			minutes = parseInt(split3[1],10);
			
			if (isNaN(minutes))
			{
				alert(errorString);
				Calendar.dateErrorOccurred = true;
				return errorDateReturn(strDate, isValidate);
			}
			if ((minutes < 0) || (minutes > 60))
			{
				alert(errorString);
				Calendar.dateErrorOccurred = true;
				return errorDateReturn(strDate, isValidate);
			}
		
			if (split3.length != 2)
			{
				var seconds = parseInt(split3[2],10);

				if (isNaN(seconds))
				{
					alert(errorString);
					Calendar.dateErrorOccurred = true;
					return errorDateReturn(strDate, isValidate);
				}
				if ((seconds < 0) || (seconds > 60))
				{
					alert(errorString);
					Calendar.dateErrorOccurred = true;
					return errorDateReturn(strDate, isValidate);
				}
			}
		}
	}
	
	if (split1.length == 3)
	{
		amPM = split1[2];
		
		if ((amPM != Calendar.AM) && (amPM != Calendar.PM))
		{
			alert(errorString);
			return errorDateReturn(strDate, isValidate);
		}
	}
	
	if (isValidate)
	{
		return formatDate(dateFormat, year, month, day, hours, minutes, seconds, amPM);
	}
	else
	{
		return new Date(year, month, day, hours, minutes, seconds, 0);
	}
}

function getTimeZone()
{
	var today = new Date();
	var hour = today.getHours();
	var hourUTC = today.getUTCHours();
	var diff = hour - hourUTC;
	var hourdifference = Math.abs(diff);
	var minute = today.getMinutes();
	var minuteUTC = today.getUTCMinutes();
	var minutedifference;
	var timezone;			
	
	if ((minute != minuteUTC) && (minuteUTC < 30) && (diff < 0))
	{ 
		hourdifference--; 
	}
	
	if ((minute != minuteUTC) && (minuteUTC > 30) && (diff > 0))
	{ 
		hourdifference--; 
	}

	if (minute != minuteUTC) 
	{
		minutedifference = "30";
	}
	else 
	{
		minutedifference = "00";
	}
	
	if (hourdifference < 10) 
	{ 
		timezone = "0" + hourdifference + minutedifference;
	}
	else 
	{
		timezone = "" + hourdifference + minutedifference;
	}
	
	if (diff < 0) 
	{
		timezone = "-" + timezone;
	}
	else 
	{
		timezone = "+" + timezone;
	}
	
	return timezone;
}

<!-- END calendar.js -->
<!-- ----------------------------------------------------------------- -->
