
<!-- ----------------------------------------------------------------- -->
<!-- BEGIN queryAndReportPrivileges.js -->
 
function isUserReportAdmin()
{
	return <!-- WSLET CODE=GetFolderSecurityInfo --><!-- PARAM NAME=IS_USER_FOLDER_ROOT_MANAGER --><!-- /WSLET -->;
}


function getSubbuttonbar()
{
	var p = window.parent;
	
	while (p)
	{
		if (p.subbuttonbar) return p.subbuttonbar;
		p = p.parent;
	}
}

function isSharedQueryOrReportFolderWritable(queryOrReportObject)
{
	var folders = getNavFrame().getWritableSharedFolders(queryOrReportObject);
	
	for (var i = 0; i < folders.length; i++)
	{
		if (folders[i] == queryOrReportObject.folder)
		{
			return true;
		}
	}
	
	return false;
}

function canDelete(queryOrReportObject, objectType)
{
	if (getSubbuttonbar().getObjectType() == "objects")
	{
		return false;
	}

	if (queryOrReportObject.type == "Personal")
	{
		return true;
	}
	else if (queryOrReportObject.type == "Shared")
	{
		if (isUserReportAdmin() || isSharedQueryOrReportFolderWritable(queryOrReportObject))
		{
			return true;
		}
		
		return false;
	}
	else
	{
		return false;
	}
}

function canSave(queryOrReportObject)
{
	// use the same rules as deletion by default
	return canDelete(queryOrReportObject);
}

function canSaveAs(queryOrReportObject)
{
	return getSubbuttonbar().getObjectType() != "objects";
}

function canShare(queryOrReportObject)
{
	if (!canSaveAs(queryOrReportObject))
	{
		return false;
	}
	
	if (isUserReportAdmin())
	{
		return true;
	}
	
	var folders = getNavFrame().getWritableSharedFolders(queryOrReportObject);
	
	if (folders.length > 0)
	{
		return true;
	}
	
	return false;
}

function canMove(queryOrReportObject)
{	
	if (getSubbuttonbar().getObjectType() == "objects")
	{
		return false;
	}
	
	switch (queryOrReportObject.type)
	{
		case "Personal":
			return true;
		case "Custom":
			if (queryOrReportObject.isNew)
				return false;
			return _canMoveSecurityCheck(queryOrReportObject);
		default:
			return _canMoveSecurityCheck(queryOrReportObject);
	}
}

function _canMoveSecurityCheck(queryOrReportObject)
{
	if (queryOrReportObject.type == "Personal" || isUserReportAdmin())
	{
		return true;
	}

	if ((!isUserReportAdmin()) && (queryOrReportObject.folder == ""))
	{
		return false;
	}

	var folders = getNavFrame().getWritableFoldersBasedOnObject(queryOrReportObject);

	if (folders.length >= 2)
	{
		return true;
	}
	
	return false;
}

function canSaveAsPromptingQuery(queryOrReportObject)
{
	if (queryOrReportObject.type == "CM")
	{
		return false;
	}
	return getSubbuttonbar().getObjectType() != "objects";
}

function canEditFormat(reportObject)
{
	if (canDelete(reportObject))
	{
		if (reportObject.sub_reports[0].auto_attr_template.length > 0)
		{
			return true;
		}
	}
	
	return false;
}

function canEditQuery(reportObject)
{
	// use the same rules as deletion by default
	return canDelete(reportObject);
}

<!-- END queryAndReportPrivileges.js -->
<!-- ----------------------------------------------------------------- -->
