<!-- ----------------------------------------------------------------- -->
/*
 * related_task_cvs.js
 *
 * Function to get task's associated cvs.
 * Provides functions for determining if
 * a task has non-static state objects.
 *
 */

<!-- WSLET CODE=PTRelation -->
<!-- PARAM NAME=CCM_TASK_OBJECT VALUE=associated_cv -->
<!-- PARAM NAME=displayname -->
<!-- PARAM NAME=status -->
<!-- /WSLET -->

function isRegistered()
{
	// XXX: assumes state name. Change this name to match that in DATABASE/pt/ptenvstr if needed.
	return 'registered' == CtrlUtils.getValue("status");
}

function isCompleted()
{
	// XXX: assumes state name. Change this name to match that in DATABASE/pt/ptenvstr if needed.
	return 'completed' == CtrlUtils.getValue("status");
}

function isAutomatic()
{
	// XXX: assumes state name. Change this name to match that in DATABASE/pt/ptenvstr if needed.
	return 'task_automatic' == CtrlUtils.getValue("status");
}

function isComponent()
{
	// XXX: assumes state name. Change this name to match that in DATABASE/pt/ptenvstr if needed.
	return 'component_task' == CtrlUtils.getValue("status");
}

function CanComplete()
{
	var i,iLen;
	var jVal;
	
	iLen = Relation_associated_cv.objects.length;
	if(iLen == 0)
		return(true);

	for(i=0;i < iLen; i++)
	{
		jVal = Relation_associated_cv.objects[i].status;

		if(
			(jVal != "integrate")&&
			(jVal != "released")&&
			(jVal != "rejected")&&
			(jVal != "test")&&
			(jVal != "sqa")&&
			(jVal != "readonly")
		  )
		{
			return(false);
		}
	}

	return(true);
}

function NonStaticObjects()
{
	var i,iLen;
	
	iLen = Relation_associated_cv.objects.length;
	if(iLen == 0)
		return;

	var w  = window.open("","ViewNonStaticObjects","resizable,scrollbars,width=400,height=400");
	var d  = w.document;
	w.focus();
	var sb = new StringBuffer();

	sb.concat("<HTML>");
	sb.concat(" <HEAD>");
	sb.concat("  <META HTTP-EQUIV=\"Content-Type\" content=\"text/html; charset=<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=CONTENT_TYPE_CHARSET --><!-- /WSLET -->\">");
	sb.concat("  <TITLE>");
	sb.concat("<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='lbl01063' --><!-- /WSLET -->");
	sb.concat("  </TITLE>");
	sb.concat(" </HEAD>");
	sb.concat(" <BODY STYLE=\"background: white; font: <!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=USER_PROFILE_VALUE --><!-- PARAM NAME=user_fontsize VALUE=10 --><!-- /WSLET -->pt Arial, Helvetica, sans-serif;\" ONLOAD=\"window.focus();\">");
	sb.concat("  <CENTER>");
	sb.concat("  <FORM ONSUBMIT=\"return(false);\">");
	sb.concat("   <TABLE WIDTH=100% CELLSPACING=0 CELLPADDING=0 BORDER=0>");
	sb.concat("    <TR>");
	sb.concat("     <TD ALIGN=left VALIGN=center>");
	sb.concat("<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='lbl01064' --><!-- /WSLET -->");
	sb.concat("     </TD>");
	sb.concat("    </TR>");
	sb.concat("    <TR>");
	sb.concat("     <TD ALIGN=left VALIGN=center>");
	sb.concat("       <TABLE WIDTH=100% CELLSPACING=2 CELLPADDING=2 BORDER=1>");
	sb.concat("         <TR>");
	sb.concat("           <TD ALIGN=left VALIGN=center>");
	sb.concat("             <TABLE WIDTH=100% CELLSPACING=2 CELLPADDING=2 BORDER=0>");

	for(i=0;i < iLen; i++)
	{
		jVal = Relation_associated_cv.objects[i].status;

		if(
			(jVal != "integrate")&&
			(jVal != "released")&&
			(jVal != "rejected")&&
			(jVal != "test")&&
			(jVal != "sqa")&&
			(jVal != "readonly")
		  )
		{
			sb.concat("<TR>");
			sb.concat("  <TD ALIGN=left VALIGN=center>");
			sb.concat(Relation_associated_cv.objects[i].displayname);
			sb.concat("  </TD>");
			sb.concat("  <TD ALIGN=left VALIGN=center>");
			sb.concat(Relation_associated_cv.objects[i].status);
			sb.concat("  </TD>");
			sb.concat("</TR>");
		}
	}
	
	sb.concat("             </TABLE>");
	sb.concat("           </TD>");
	sb.concat("         </TR>");
	sb.concat("       </TABLE>");
	sb.concat("     </TD>");
	sb.concat("    </TR>");
	sb.concat("   </TABLE>");
	sb.concat("   <HR>");
	sb.concat("   <BUTTON TYPE=\"button\" ONCLICK=\"javascript:self.close()\" TITLE=\"<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='alt00003' --><!-- /WSLET -->\"><!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='lbl00120' --><!-- /WSLET --></BUTTON>");
	sb.concat("  </FORM>");
	sb.concat("  </CENTER>");
	sb.concat(" </BODY>");
	sb.concat("</HTML>");

	d.write(sb.toString());
	d.close();
}

<!-- END related_task_cvs.js -->
<!-- ----------------------------------------------------------------- -->
