/**
 * File: pt/include/user_framework/report_completion_status.js
 * This javascript is used to poll for report update and 
 * update the progress bar periodically.
 */

dojo.require('dojo.parser');
dojo.require('dijit.ProgressBar');

var progress = "";
var reportData = "";
var phases = "";
var errors = false;

var spinningWait = '<IMG BORDER="0" src="<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SERVLET_PATH VALUE=PTIMAGES_PATH --><!-- /WSLET -->spinningWait.gif"/>';
var phaseDone = '<IMG BORDER="0" src="<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SERVLET_PATH VALUE=PTIMAGES_PATH --><!-- /WSLET -->ws_successicon_sm.gif"/>';

var mainQueryMessage = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='runMainQuery' --><!-- PARAM NAME=BUNDLE VALUE='52_patch' --><!-- /WSLET -->";
var relationLookupMessageNA = "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='relationLookupNA' --><!-- PARAM NAME=BUNDLE VALUE='52_patch' --><!-- /WSLET -->"; 
var interval;

/**
 * Makes dojo ajax call to submit a form.
 * @param formToSubmit Form name.
 * @return
 */
function ajaxSubmitForm(formToSubmit)
{
	//Make an Ajax call to get the report details.					
	dojo.xhrGet(
	{
		form: formToSubmit,
		content: {"sendJsonData": true},
		load: function(data)
		{																				
			initialize(data);
		},										
		error: function(err)
		{
			// Do nothing.
		}
	});
}


/**
 * Initialize report related data.
 * @param data from server.
 * @return
 */
function initialize(data)
{
	var data1 = data.split("#");
	
	// Some server side errors
	if (data1.length == 1)
	{
		var retData = eval("(" + data1[0] + ")");			
		
		if (retData.rportError) 
		{
			clearInterval(interval);// Clear the interval.
			displayServersideErrors(rptErr.errorMessage);			
		}
	}
	
	// Report is ready, submit form to get the report template.
	// Though this is very corner case as long reports will not 
	// be over soon. If this happens then report wont be loaded at all.  
	// Fixing this.	
	if (data1.length == 2)
	{		
		var rptData = eval("(" + data1[0] + ")");
		var formData = eval("(" + data1[1] + ")");				
		
		if (rptData.rportReady)
		{
			clearInterval(interval);// Clear the interval.
			populateFormData(formData);
			submitForm();			
		}
		
		return;
	}
	
	progress = eval("(" + data1[0] + ")");
	reportData = eval("(" + data1[1] + ")");
	phases = eval("(" + data1[2] + ")");
	
	populateFormData(reportData);
	
	var relation = document.getElementById(phases.relationshipLookup);
	relation.reportHasThisPhase = "true";
	
	// If no raltion lookups then modify the message.
	if (progress.operations == 2)
	{
		relation.innerHTML = "&nbsp;" + relationLookupMessageNA;
		relation.reportHasThisPhase = "false";				
	}

	// Start the polling to get the latest progress of the report. 
	startPolling(reportData.waitBetweenPollingMiliSecs);
}


/**
 * Populates the form data
 * @param data Report data.
 * @return void.
 */
function populateFormData(data)
{
	with (window.document.ptReportLoad)
	{
		CCM_FILE.value = data.reportFile;
		REPORT_REPORTNAME.value = data.reportName;
		REPORT_FORM_TYPE.value = data.reportType;
		
		long_request_id.value = data.longRequestId;
		role.value = data.role;
		token.value = data.token;
	}
}


/**
 * Makes an jax call to get the details. 	
 */
function startPolling(duration)
{
	// Get the report status every 4 (or configured value) secs.
	// FIXME: There is some issue with the way error handler is invoked 
	// by dojo ajax calls. For example if an ajax call is still running and user makes 
	// another request or clicks another link then also error handler is invoked. 
	// For this page if the polling time is less that 500ms then you might see 
	// Error message being displayed. Note that this is not reproducible very frequently. 
	// Need to investigate this.
	interval = setInterval(function()	
	{
		dojo.xhrGet(
		{
			form: document.ptReportLoad,
			load: callback,
			handleAs: "json",
			error: errorHandler
		});
	}, duration);
}


/**
 * Ajax callback function. 
 */
function callback(reportdata)
{
	// Network restored, remove error message.
	displayNetworkError(false);
	
	var progres = reportdata;
	
	// If server side error submit to load the error template. 
	if (progres.rportError)
	{
		clearInterval(interval);// Clear the interval.
		displayServersideErrors(progres.errorMessage);
		return;
	}

	// If report is ready then submit the form to load report template.
	// We could do "body.innerHTML = reportdata" to load the report data, 
	// but scripts will not be executed. There are workarounds but not consistent.
	// So this template will have 'n' Ajax calls and one submit() to load
	// report template.
	if (progres.rportReady)
	{
		clearInterval(interval);// Clear the interval.
		submitForm();
		return;
	}

	var phaseMessages = progres.message.split('|');
	
	// Update progress bar.
	if (progres.phase != phases.mainQuery)
	{
		bar.update({maximum: progres.operations, indeterminate: false, progress: progres.progress});
	}

	// Update the messages of the progress bar.	
	switch (progres.phase)
	{
		case phases.mainQuery:
		{
			// Still executing main query, no need to update. 
			break;
		}
		case phases.relationshipLookup:
		{	
			document.getElementById(phases.mainQuery + "_icon").innerHTML = phaseDone;
			document.getElementById(phases.mainQuery).innerHTML = "&nbsp;" + phaseMessages[0] + "";
			
			document.getElementById(phases.relationshipLookup + "_icon").innerHTML = spinningWait;
			document.getElementById(phases.relationshipLookup).innerHTML = "<b>&nbsp;" + phaseMessages[1] + "</b>";
			break;
		}
		case phases.formatResults:
		{
			var relationshipLookup = document.getElementById(phases.relationshipLookup);
			
			document.getElementById(phases.mainQuery + "_icon").innerHTML = phaseDone;
			document.getElementById(phases.mainQuery).innerHTML = "&nbsp;" + phaseMessages[0];

			document.getElementById(phases.relationshipLookup + "_icon").innerHTML = phaseDone;							
			if ("true" == relationshipLookup.reportHasThisPhase)
			{
				relationshipLookup.innerHTML = "&nbsp;" + phaseMessages[1];
			}
			else
			{
				relationshipLookup.innerHTML = "&nbsp;" + relationLookupMessageNA;
			}
			
			document.getElementById(phases.formatResults + "_icon").innerHTML = spinningWait; 
			document.getElementById(phases.formatResults).innerHTML = "<b>&nbsp;" + phaseMessages[2] + "</b>";
			break;
		}
	}
}

function errorHandler(error)
{
	// FIXME: Need a clean way to detect availability of internet connection. 
	// I do not know at this point of time, need some more investigation.  
	
	// For IE - ERROR_INTERNET_CANNOT_CONNECT (12029) is the error code when 
	// browser tries to connect to the server and fails. This might occur even if 
	// fire-wall is preventing the request.
	// For FF - The status code returned is zero (0).
	// IE returns 12xxx error codes and FF returns less than 1 (zero) for 
	// network related errors.			
	if ((error.status < 1 /*FF*/) || (error.status >= 12000 /*IE*/))
	{
		displayNetworkError(true);
	}
}


/**
 * Submits the for toad report results or error template.
 */
function submitForm()
{
	with (window.document.ptReportLoad)
	{
		method = "POST";
		target = "_self";
		sendJsonData.value = "false";
		
		submit();
	}
}


/**
 * Displays the errors if any. 
 */
function displayNetworkError(show)
{
	if (show)
	{
		document.getElementById("errorMessage").style.display = "";
		errors = true;
	}
	else if(errors)
	{
		document.getElementById("errorMessage").style.display = "none";
		errors = false;
	}
}


/**
 * Displays the server side errors if any. 
 * @param errMsg Error message.
 * @return nothing.
 */
function displayServersideErrors(errMsg)
{
	var errBegin = 
	'<DIV ID="statusInfo" STYLE="height: 100%; width: 100%;">' +
		'<TABLE HEIGHT="100%">' +
			'<TR>' +
				'<TD VALIGN="center">' +							
					'<IMG SRC="<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SERVLET_PATH VALUE=PTIMAGES_PATH --><!-- /WSLET -->ws_erroricon_sm.gif" BORDER=0>&nbsp' +
					'<SPAN ID="message">&nbsp;';
	var errEnd =	'</SPAN>' +
				'</TD>' +
			'</TR>' +
		'</TABLE>' +
	'</DIV>';
	
	// Replace the hole window with error content.
	window.document.body.innerHTML = errBegin + errMsg + errEnd;
}
