<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- reports\user_framework\adhoc_matrix_rpt.jsp -->
<%@ page import="java.util.*"%>
<%@ page import="com.telelogic.cs.report.*"%>
<%@ page import="com.telelogic.cs.api.User"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<%--
	c:if is used for a single if conditional test.
--%>
<c:if test="${queryResults.hasErrorMessage}">
	<%--
		If there is an error use c:set to set a variable in the request object called
		errorMessage and forward on to the error page.
	--%>
	<c:set value="${queryResults.errorMessage}" var="errorMessage" scope="request"/>
	<c:set var="infoIcon" scope="request">
		<c:if test="${queryResults.errorType == 3}">true</c:if>
	</c:set>
	<jsp:forward page="/WEB-INF/wsconfig/templates/pt/forms/block_message.jsp"/>
</c:if>

<c:if test="${homePageReport != 'true'}">
<html>
<head>
	<title>
		<change:wsletExpander>
			<!-- WSLET CODE=PTLoadData -->
     		<!-- PARAM NAME=CCM_WINDOW_LABEL -->
			<!-- /WSLET -->
		</change:wsletExpander>
	</title>
	
	<style type="text/css">
<!--

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/report.css -->
	<!-- /WSLET -->
</change:wsletExpander>
	
td.center
{
	text-align: center;
}
-->
	</style>
</head>
<body>
</c:if>

<c:if test="${homePageReport != 'true'}">
	<jsp:include page="/WEB-INF/wsconfig/templates/pt/reports/user_framework/adhocHeader.jsp"/>
	<hr>
	<br>
</c:if>

<script type="text/javascript">
	var database = <change:javaScriptEscape value="${user.database}"/>;
	var role = <change:javaScriptEscape value="${user.role}"/>;
</script>
<%-- 
	scriplet to process and create the matrix information.
--%>
<%
	MatrixReport matrixReport = new MatrixReport();	
	
	QueryResults queryResults = (QueryResults) request.getAttribute("queryResults");
	List reportAttributes = queryResults.getReportAttributes();
	
	String attribute1 = (String) reportAttributes.get(0);
	String attribute2 = (String) reportAttributes.get(1);
	
	List queryResultsItems = queryResults.getQueryResultItems();
	
	out.println("<!-- count = " + queryResultsItems.size() + " -->");
						
	QueryResultsItem queryResultsItem = null;
	
	for (int i = 0; i < queryResultsItems.size(); i++)
	{
		queryResultsItem = (QueryResultsItem) queryResultsItems.get(i);
		QueryResultsAttribute queryAttr1 = (QueryResultsAttribute) queryResultsItem.getAttribute(attribute1);
		QueryResultsAttribute queryAttr2 = (QueryResultsAttribute) queryResultsItem.getAttribute(attribute2);
		
		matrixReport.update(queryAttr1, queryAttr2);
	}

	matrixReport.setRowHeader(queryResultsItem.getAttribute(attribute1).getLabel());
	matrixReport.setColumnHeader(queryResultsItem.getAttribute(attribute2).getLabel());
	
	matrixReport.normalize();
	
	pageContext.setAttribute("matrixReport", matrixReport);
%>

<center>
<table id="matrixTable" border="1" cellspacing="0" cellpadding="5" style="empty-cells: show;">
<c:set var="rowNames" value="${matrixReport.rowNames}"/>
<c:set var="columnNames" value="${matrixReport.columnNames}"/>

<c:forEach var="matrixRow" items="${matrixReport.matrixRows}" varStatus="status">
	<tr>
	<c:choose>
		<c:when test="${status.index == 0}">
			<td rowspan="2" colspan="2">&nbsp;</td><th colspan="${fn:length(columnNames)+1}">${matrixReport.columnHeader}</th></tr>
			
			<tr>
			<c:forEach var="columnName" items="${columnNames}" varStatus="colStatus">
				<td class="center">
					<c:choose>
						<c:when test="${columnNames[colStatus.index] == ''}">
							<change:resource key="notSet"/>
						</c:when>
						<c:otherwise>
							${columnNames[colStatus.index]}
						</c:otherwise>
					</c:choose>
				</td>
			</c:forEach>
				<td class="center">
					<change:resource key="totals"/>
				</td>
			</tr>
			<tr><th rowspan="${fn:length(rowNames)+1}">
				<c:forEach var="i" begin="1" end="${fn:length(matrixReport.rowHeader)}">
					${fn:substring(matrixReport.rowHeader, i-1, i)}<br/>
				</c:forEach>
			</th>
				<td>
					<c:choose>
						<c:when test="${rowNames[status.index] == ''}">
							<change:resource key="notSet"/>
						</c:when>
						<c:otherwise>
							${rowNames[status.index]}
						</c:otherwise>
					</c:choose>
				</td>
		</c:when>
		<c:otherwise>
			<td>
				<c:choose>
					<c:when test="${rowNames[status.index] == ''}">
						<change:resource key="notSet"/>
					</c:when>
					<c:otherwise>
						${rowNames[status.index]}
					</c:otherwise>
				</c:choose>	
			</td>
		</c:otherwise>
	</c:choose>
	<c:forEach var="matrixColumn" items="${matrixRow.matrixColumns}" varStatus="colStatus">
		<td class="center">
			<c:choose>
				<c:when test="${matrixColumn.size > 0}">
					<a href="#" onclick="javascript:loadCrColumnDrillDown(${status.index}, ${colStatus.index}, '${matrixColumn.cvidListAsString}')">${matrixColumn.size}</a>
				</c:when>
				<c:otherwise>
					${matrixColumn.size}
				</c:otherwise>
			</c:choose>
		</td>
	</c:forEach>		
		<td class="center">
			<c:choose>
				<c:when test="${matrixRow.size > 0}">
					<a href="#" onclick="javascript:loadCrRowTotalDrillDown(${status.index} , '${matrixRow.cvidListAsString}')">${matrixRow.size}</a>
				</c:when>
				<c:otherwise>
					${matrixRow.size}
				</c:otherwise>
			</c:choose>
		</td>
	</tr>
</c:forEach>
	<tr>
		<td>
			<change:resource key="totals"/>
		</td>
		<c:set var="user" value="${user}"/>
		<%
			User user = (User) pageContext.getAttribute("user");
			List columnNames = (List) pageContext.getAttribute("columnNames");
						
			for (int i = 0; i < columnNames.size(); i++)
			{
				String name = (String) columnNames.get(i);
				MatrixColumnTotal columnTotal = matrixReport.getMatrixColumnTotal(name);
				
				if (columnTotal.getTotal() > 0)
				{
					out.println("<td class=\"center\">");
					out.println("<a href='#' " + "onclick=" + "'javascript:loadCrColumnTotalDrillDown(" + i + ",\"" + columnTotal.getCvidListAsString() + "\")'>" + columnTotal.getTotal() + "</a>");
					out.println("</td>");
				}
				else
				{
					out.println("0");
				}
			}
			
			out.println("<td class=\"center\">");
			out.println("<a href='#' " + "onclick=" + "'javascript:loadCrAllDrillDown(\"" + matrixReport.getAllCvidsAsString() + "\")'>" + matrixReport.getTotal() + "</a>");
			out.println("</td>");
		%>
	</tr>
</table>
</center>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=custom_controls/matrixReport.CUSTOM -->
	<!-- /WSLET -->
</change:wsletExpander>

<c:if test="${homePageReport != 'true'}">
</body>
</html>
</c:if>
